<?php

include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.ccurl.inc');

if($argv[1]=="--count"){PatternsCount();exit;}

Startx();
function Startx(){

    $unix=new unix();
    $tar=$unix->find_program("tar");
    $rm=$unix->find_program("rm");
    $php=$unix->LOCATE_PHP5_BIN();

    $TMP=$unix->FILE_TEMP();
    $curl=new ccurl("http://articatech.net/ufdbv4/modsecurity.txt");
    if(!$curl->GetFile($TMP)){
        squid_admin_mysql(1,"Unable to fetch ModSecurity pattern index",@implode("\n",$curl->errors),__FILE__,__LINE__);
        return;
    }

    $iniArry=unserialize(base64_decode(@file_get_contents($TMP)));

    $oldIniArry=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityPattern")));
    @unlink($TMP);

    if(!CheckTargets()){
        $oldIniArry["zDate"]=0;
    }

    if($oldIniArry["zDate"]==$iniArry["zDate"]){
        echo "Nothing to do...\n";
        return;
    }

    echo "Downloading file....\n";
    $TMP=$unix->FILE_TEMP().".tar.gz";
    $curl=new ccurl("http://articatech.net/ufdbv4/modsecurity.tar.gz");
    if(!$curl->GetFile($TMP)){
        squid_admin_mysql(1,"Unable to fetch ModSecurity pattern database",@implode("\n",$curl->errors),__FILE__,__LINE__);
        return;
    }

    $md5=md5_file($TMP);

    if($md5<>$iniArry["md5"]){
        @unlink($TMP);
        squid_admin_mysql(1,"Unable to fetch ModSecurity pattern database (corrupted file)","$md5 differ {$iniArry["md5"]}",__FILE__,__LINE__);
        return;

    }

    echo "Extracting file....\n";
    if(!is_dir("/etc/nginx/owasp-modsecurity-crs")){
        @mkdir("/etc/nginx/owasp-modsecurity-crs",0755,true);
    }


    system("$tar xf $TMP -C /etc/nginx/owasp-modsecurity-crs/");
    squid_admin_mysql(1,"Success update new ModSecurity pattern","",__FILE__,__LINE__);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ModSecurityPattern",base64_encode(serialize($iniArry)));
    system("$php /usr/share/artica-postfix/exec.ModSecurity.install.php --build");
    PatternsCount();


}

function PatternsCount(){

    $unix=new unix();
    $grep=$unix->find_program("grep");
    $wc=$unix->find_program("wc");

    exec("$grep -RE \"id:[0-9]+\" /etc/nginx|$wc -l 2>&1",$results);
    foreach ($results as $line){
        $line=trim($line);
        if(preg_match("#^([0-9]+)#",$line,$re)){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ModSecurityPatternCount",$re[1]);
            break;
        }
    }

    $f=explode("\n",@file_get_contents("/etc/nginx/owasp-modsecurity-crs/REQUEST-901-INITIALIZATION.conf"));
    foreach ($f as $line){
        $line=trim($line);
        if(!preg_match("#^SecComponentSignature.*?\"(.+?)\"#",$line,$re)){continue;}
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ModSecurityPatternVersion",$re[1]);
        break;
    }



}

function CheckTargets(){
    $Includes[]="REQUEST-900-EXCLUSION-RULES-BEFORE-CRS.conf";
    $Includes[]="REQUEST-901-INITIALIZATION.conf";
    $Includes[]="REQUEST-903.9001-DRUPAL-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-903.9002-WORDPRESS-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-903.9003-NEXTCLOUD-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-903.9004-DOKUWIKI-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-903.9005-CPANEL-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-903.9006-XENFORO-EXCLUSION-RULES.conf";
    $Includes[]="REQUEST-905-COMMON-EXCEPTIONS.conf";
    $Includes[]="REQUEST-910-IP-REPUTATION.conf";
    $Includes[]="REQUEST-911-METHOD-ENFORCEMENT.conf";
    $Includes[]="REQUEST-912-DOS-PROTECTION.conf";
    $Includes[]="REQUEST-913-SCANNER-DETECTION.conf";
    $Includes[]="REQUEST-920-PROTOCOL-ENFORCEMENT.conf";
    $Includes[]="REQUEST-921-PROTOCOL-ATTACK.conf";
    $Includes[]="REQUEST-930-APPLICATION-ATTACK-LFI.conf";
    $Includes[]="REQUEST-931-APPLICATION-ATTACK-RFI.conf";
    $Includes[]="REQUEST-932-APPLICATION-ATTACK-RCE.conf";
    $Includes[]="REQUEST-933-APPLICATION-ATTACK-PHP.conf";
    $Includes[]="REQUEST-934-APPLICATION-ATTACK-NODEJS.conf";
    $Includes[]="REQUEST-941-APPLICATION-ATTACK-XSS.conf";
    $Includes[]="REQUEST-942-APPLICATION-ATTACK-SQLI.conf";
    $Includes[]="REQUEST-943-APPLICATION-ATTACK-SESSION-FIXATION.conf";
    $Includes[]="REQUEST-944-APPLICATION-ATTACK-JAVA.conf";
    $Includes[]="REQUEST-949-BLOCKING-EVALUATION.conf";
    $Includes[]="RESPONSE-950-DATA-LEAKAGES.conf";
    $Includes[]="RESPONSE-951-DATA-LEAKAGES-SQL.conf";
    $Includes[]="RESPONSE-952-DATA-LEAKAGES-JAVA.conf";
    $Includes[]="RESPONSE-953-DATA-LEAKAGES-PHP.conf";
    $Includes[]="RESPONSE-954-DATA-LEAKAGES-IIS.conf";
    $Includes[]="RESPONSE-959-BLOCKING-EVALUATION.conf";
    $Includes[]="RESPONSE-980-CORRELATION.conf";
    $Includes[]="RESPONSE-999-EXCLUSION-RULES-AFTER-CRS.conf";

    $rules_path="/etc/nginx/owasp-modsecurity-crs";


    foreach ($Includes as $filename){
        if(!is_file("$rules_path/$filename")){
            echo "Missing $rules_path/$filename\n";
            return false;
        }

    }

    return true;

}