<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.modsecurity.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.postgres.inc');

if(!isset($GLOBALS["CLASS_SOCKETS"])){
    if(!class_exists("sockets")){
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
}



if($argv[1]=="--install"){install();exit;}
if($argv[1]=="--uninstall"){uninstall();exit;}
if($argv[1]=="--build"){build();}

function build_progress($text,$pourc){
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/modsecurity.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "{$pourc}%: $text\n";
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);
}

function install(){
    $unix=new unix();
    build_progress("{installing}",20);
    $php=$unix->LOCATE_PHP5_BIN();
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableModSecurityIngix",1);

    $unix->Popuplate_cron_make("ModSecurity","45 5 * * *","exec.ModSecurity.download.php");
    $unix->Popuplate_cron_make("ModSecurity-Parse","* * * * *","exec.modsecurity-parse.php --scan");

    shell_exec("/etc/init.d/cron reload");
    build_progress("{updating}",50);
    if(!is_dir("/etc/nginx/owasp-modsecurity-crs")){
        @mkdir("/etc/nginx/owasp-modsecurity-crs",0755,true);
    }

    if(!is_file("/etc/ld.so.conf.d/modsecurity.conf")){
        @file_put_contents("/etc/ld.so.conf.d/modsecurity.conf","/usr/local/modsecurity/lib\n");
        shell_exec("/usr/sbin/ldconfig");
    }
    if(!is_dir("/home/artica/modsecurity")){
        @mkdir("/home/artica/modsecurity",0755,true);
    }

    chown("/home/artica/modsecurity","www-data");
    chgrp("/home/artica/modsecurity","www-data");

    build_progress("{installing}",60);
    $q=new postgres_sql();
    $q->create_modsecurity_tables();


    shell_exec("$php /usr/share/artica-postfix/exec.ModSecurity.download.php");
    build_progress("{done}",100);
}


function uninstall(){
    $unix=new unix();
    build_progress("{uninstalling}",20);
    $rm=$unix->find_program("rm");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableModSecurityIngix",0);
    if(is_file("/etc/cron.d/ModSecurity")){
        build_progress("{uninstalling}",30);
        @unlink("/etc/cron.d/ModSecurity");
        shell_exec("/etc/init.d/cron reload");
    }
    if(is_file("/etc/cron.d/ModSecurity-Parse")){
        build_progress("{uninstalling}",33);
        @unlink("/etc/cron.d/ModSecurity-Parse");
        shell_exec("/etc/init.d/cron reload");
    }

    @unlink("/var/log/modsec_parse.log");

    if(is_dir("/etc/nginx/owasp-modsecurity-crs")){
        build_progress("{uninstalling}",50);
        shell_exec("$rm -rf /etc/nginx/owasp-modsecurity-crs");
    }

    if(is_dir("/home/artica/modsecurity")){
        build_progress("{uninstalling}",55);
        shell_exec("$rm -rf /home/artica/modsecurity");
    }

    $prc=55;

    $tables[]="modsecurity_events";
    $tables[]="modsecurity_patterns";
    $tables[]="modsecurity_titles";
    $tables[]="modsecurity_vers";
    $tables[]="modsecurity_hosts";
    $tables[]="modsecurity_uris";
    $tables[]="modsecurity_explains";
    $tables[]="modsecurity_reports";
    $tables[]="modsecurity_tags";
    $tables[]="modsecurity_linked_tags";

    $q=new postgres_sql();
    foreach ($tables as $table){
        $prc++;
        build_progress("{removing} $table",$prc);
        $q->QUERY_SQL("DROP TABLE $table");
    }




    build_progress("{uninstalling} {done}",100);
}

function build(){

    build_progress("{configuring}",20);
    $modsec=new mod_security();
    $modsec->mod_security_loader();
    build_progress("{reloading}",50);
    system("/etc/init.d/nginx reload");
    chown("/home/artica/modsecurity","www-data");
    chgrp("/home/artica/modsecurity","www-data");
    build_progress("{configuring} {done}",100);
}



