<?php
if (!isset($GLOBALS["CLASS_SOCKETS"])) {
    if (!class_exists("sockets")) {
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"] = new sockets();
}
if (function_exists("posix_getuid")) {
    if (posix_getuid() <> 0) {
        die("Cannot be used in web server mode\n\n");
    }
}
include_once(dirname(__FILE__).'/framework/class.unix.inc');
include_once(dirname(__FILE__)."/framework/frame.class.inc");
$GLOBALS["FORCE"] = false;
$GLOBALS["RECONFIGURE"] = false;
$GLOBALS["SWAPSTATE"] = false;
$GLOBALS["NOSQUIDOUTPUT"] = true;
$GLOBALS["TITLENAME"] = "Categories Service";
if (preg_match("#--verbose#", implode(" ", $argv))) {
    $GLOBALS["VERBOSE"] = true;
    $GLOBALS["OUTPUT"] = true;
    $GLOBALS["debug"] = true;
    ini_set('display_errors', 1);
    ini_set('error_reporting', E_ALL);
    ini_set('error_prepend_string', null);
    ini_set('error_append_string', null);
}
if (preg_match("#--output#", implode(" ", $argv))) {
    $GLOBALS["OUTPUT"] = true;
}
if (preg_match("#schedule-id=([0-9]+)#", implode(" ", $argv), $re)) {
    $GLOBALS["SCHEDULE_ID"] = $re[1];
}
if (preg_match("#--force#", implode(" ", $argv), $re)) {
    $GLOBALS["FORCE"] = true;
}
if (preg_match("#--reconfigure#", implode(" ", $argv), $re)) {
    $GLOBALS["RECONFIGURE"] = true;
}
if($argv[1]=="--delete-databases"){delete_databases();exit;}
if($argv[1]=="--start"){start();}
if($argv[1]=="--install"){install();}
if($argv[1]=="--uninstall"){uninstall();}
if($argv[1]=="--restart"){restart();}
if($argv[1]=="--check"){check_migration();}
if($argv[1]=="--reload"){reload();}




function build_progress_install($text,$pourc){
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/dnscatz.install.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]},{$pourc}% $text...\n";
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}


function check_migration(){

    $EnableLocalUfdbCatService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableLocalUfdbCatService"));
    if($EnableLocalUfdbCatService==0){
        return true;
    }

    if(is_file("/etc/init.d/ufdbcat")){
        squid_admin_mysql(0,"Important! Migrating Categories service to revision 2...",null,__FILE__,__LINE__);
        install();
    }

}

function install(){
    $unix = new unix();
    build_progress_install("{install_service}", 20);

    if(!is_file("/usr/share/artica-postfix/bin/install/rbldnsd")){
        build_progress_install("{install_service} {failed} rbldnsd: No such binary", 110);
    }

    @copy("/usr/share/artica-postfix/bin/install/rbldnsd","/usr/sbin/dnscatz");
    @chmod("/usr/sbin/dnscatz",0755);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableLocalUfdbCatService", 1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseCloudArticaCategories", 1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnablePersonalCategories", 1);

    $unix->Popuplate_cron_make("backup-categories","30 0 * * *","exec.backup-categories4x.php");
    shell_exec("/etc/init.d/cron reload");

    build_progress_install("{install_service}", 30);
    remove_old();
    build_progress_install("{install_service}", 35);
    install_service();
    build_progress_install("{install_service}", 40);
    monit_config();
    build_progress_install("{install_service}", 50);
    $php=$unix->LOCATE_PHP5_BIN();
    shell_exec("$php /usr/share/artica-postfix/exec.compile.categories.php");
    start();
    build_progress_install("{install_service} {success}", 100);


}

function uninstall(){
    $unix=new unix();
    $rm=$unix->find_program("rm");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableLocalUfdbCatService", 0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseCloudArticaCategories", 0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnablePersonalCategories", 0);
    $ROOT_DIR="/home/artica/dnscatz/dsbl";
    build_progress_install("{uninstall_service}", 20);
    @unlink("/etc/monit/conf.d/dnscatz.monitrc");
    system("/etc/init.d/monit restart");
    build_progress_install("{uninstall_service}", 30);
    remove_service("/etc/init.d/dnscatz");
    build_progress_install("{uninstall_service}", 50);

    if(is_file("/etc/cron.d/backup-categories")){
        @unlink("/etc/cron.d/backup-categories");
        shell_exec("/etc/init.d/cron reload");
    }

    if(is_dir($ROOT_DIR)){
        shell_exec("$rm -rf $ROOT_DIR");
    }
    build_progress_install("{uninstall_service}", 80);
    remove_old();
    build_progress_install("{uninstall_service} {done}", 100);
}

function monit_config(){
    $f=array();
    $f[]="check process APP_UFDBCAT";
    $f[]="with pidfile /var/run/dnscatz.pid";
    $f[]="start program = \"/etc/init.d/dnscatz start --monit\"";
    $f[]="stop program =  \"/etc/init.d/dnscatz stop --monit\"";
    $f[]="if 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/dnscatz.monitrc", @implode("\n", $f));
    system("/etc/init.d/monit restart");
    //********************************************************************************************************************
}

function reload(){
    $unix=new unix();
    $pid=PID_NUM();

    if($unix->process_exists($pid)){
        echo "Reloading $pid...\n";
        $kill=$unix->find_program("kill");
        shell_exec("$kill -SIGHUP $pid");
        return;
    }

    start();
}

function restart(){


    build_progress_restart("{stopping} {APP_UFDBCAT}",10);
    if(!stop()){
        build_progress_restart("{stopping} {APP_UFDBCAT} {failed}",110);
        return;
    }
    build_progress_restart("{starting} {APP_UFDBCAT}",50);
    if(!start()){
        build_progress_restart("{starting} {APP_UFDBCAT} {failed}",110);
        return;
    }
    build_progress_restart("{starting} {APP_UFDBCAT} {success}",100);
}

function start(){
    $unix=new unix();
    $ROOT_DIR="/home/artica/dnscatz/dsbl";
    $unix->SystemCreateUser("dnscatz","dnscatz");
    if(!is_dir($ROOT_DIR)){@mkdir($ROOT_DIR,0755,true);}
    @chown($ROOT_DIR,"dnscatz");
    @chgrp($ROOT_DIR, "dnscatz");

    $DnscatzInterface=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("DnscatzInterface");
    $DnsCatzPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DnsCatzPort"));
    $DnscatzDomain=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("DnscatzDomain");
    $DnsCatzTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DnsCatzTTL"));
    if($DnscatzInterface==null){$DnscatzInterface="lo";}
    if($DnscatzDomain==null){$DnscatzDomain="catz.localhost.localdomain";}

    $IpToListen="127.0.0.1";
    if($DnsCatzTTL==0){$DnsCatzTTL=35;}
    if($DnsCatzPort==0){$DnsCatzPort=3477;}
    if($DnscatzInterface<>"lo") {
        $IpToListen = $unix->InterfaceToIPv4($DnscatzInterface);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("DnscatzBindIP",$IpToListen);
    }
    $files=array();
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Scanning $ROOT_DIR\n";
    $handle = opendir($ROOT_DIR);
    if($handle) {
        while (false !== ($filename = readdir($handle))) {
            if ($filename == ".") {
                continue;
            }
            if ($filename == "..") {
                continue;
            }
            $targetFile = "$ROOT_DIR/$filename";
            if (is_dir($targetFile)) {
                continue;
            }
            if (!preg_match("#^[0-9]+$#", $filename)) {
                echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} skip file $filename\n";
                continue;
            }
            $files[] = $filename;
        }
    }

    if(count($files)==0) {
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} no category found, set defaults instead..\n";
        $files[] = "forward";
        $files[] = "personal";
        $files[] = "cache";
    }
    foreach ($files as $filename){
        if(!is_file("$ROOT_DIR/$filename")){@touch("$ROOT_DIR/$filename");}
        @chown("$ROOT_DIR/$filename","dnscatz");
        @chgrp("$ROOT_DIR/$filename", "dnscatz");
    }

    $DnsCatzTTL=$DnsCatzTTL*60;

    $f[]="/usr/sbin/dnscatz";
    $f[]="-u dnscatz:dnscatz";
    $f[]="-t {$DnsCatzTTL}";
    $f[]="-l /var/log/dnscatz.log";
    $f[]="-s /var/log/dnscatz-stats.log";
    $f[]="-p/var/run/dnscatz.pid";
    $f[]="-r$ROOT_DIR";
    $f[]="-b $IpToListen/$DnsCatzPort";
    $f[]="$DnscatzDomain:dnset:".@implode(",",$files);


    if(is_file("/var/run/dnscatz.pid")){@unlink("/var/run/dnscatz.pid");}

    if(!is_file("/var/log/dnscatz.log")){
        @touch("/var/log/dnscatz.log");
        @chmod("/var/log/dnscatz.log",0755);
        @chown("/var/log/dnscatz.log","dnscatz");
    }

    $cmd=@implode(" ", $f) ." >/tmp/dnscatz.start 2>&1 &";
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service\n";

    shell_exec($cmd);

    for($i=1;$i<5;$i++){
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";
        sleep(1);
        $pid=PID_NUM();
        if($unix->process_exists($pid)){break;}
    }

    $f=explode("\n",@file_get_contents("/tmp/dnscatz.start"));
    foreach ($f as $line){
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} \"$line\"\n";

    }

    $pid=PID_NUM();
    if($unix->process_exists($pid)){
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";
        @unlink("/tmp/dnscatz.start");
        return true;

    }

    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";
    $f=explode("\n",@file_get_contents("/tmp/dnscatz.start"));
    foreach ($f as $line){if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $line\n";}}
    @unlink("/tmp/dnscatz.start");
    return false;

}

function compile_categories(){
    $q          = new postgres_sql();

}


function install_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/dnscatz";
    $php5script=basename(__FILE__);
    $daemonbinLog="Categorize Daemon";


    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:         dnscatz";
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";

    $f[]="case \"\$1\" in";
    $f[]=" start)";
    $f[]="	  export MALLOC_ARENA_MAX=16 || true";
    $f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]=" reload)";
    $f[]="	  export MALLOC_ARENA_MAX=16 || true";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reload} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));


    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");

    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }


}

function remove_old(){
    if(is_file("/etc/monit/conf.d/ufdbcat.monitrc")){@unlink("/etc/monit/conf.d/ufdbcat.monitrc");system("/etc/init.d/monit restart");}
    if(is_file("/etc/init.d/ufdbcat")){remove_service("/etc/init.d/ufdbcat");system("/etc/init.d/monit restart");}
    if(is_file("/etc/init.d/ufdbcat-tail")){remove_service("/etc/init.d/ufdbcat-tail");}
    if(is_file("/etc/cron.d/stats-categorize")){@unlink("/etc/cron.d/stats-categorize");shell_exec("/etc/init.d/cron reload");}

    if(is_dir("/home/ufdbcat")){$unix=new unix(); $rm=$unix->find_program("rm"); shell_exec("$rm -rf /home/ufdbcat"); }

    $php[]="exec.ufdbcat-tail.php";
    $php[]="exec.ufdbcat-watchdog.php";
    $php[]="exec.ufdbcat.php";
    $php[]="exec.ufdbcat.check.php";

    foreach ($php as $file){
        if(is_file("/usr/share/artica-postfix/$file")){@unlink("/usr/share/artica-postfix/$file");}
    }

}
function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){ shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1"); }
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}
function build_progress_restart($text,$pourc){
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/dnscat.restart.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}

function build_progress_delete($text,$pourc){
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/dansguardian2.databases.delete.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}
function delete_databases(){
    $PossibleDirs[]="/var/lib/ufdbartica";
    $PossibleDirs[]="/home/ufdbcat";
    $PossibleDirs[]="/var/lib/ftpunivtlse1fr";
    $unix=new unix();
    build_progress_delete("{delete} {databases}",10);
    $rm=$unix->find_program("rm");
    foreach ($PossibleDirs as $index=>$Directory){
        if(!is_dir($Directory)){continue;}
        build_progress_delete("{delete} $Directory",50);
        shell_exec("$rm -rf $Directory/");
    }
    build_progress_delete("{reconfigure}",80);
    $php=$unix->LOCATE_PHP5_BIN();

    $files["/usr/share/artica-postfix/ressources/logs/ARTICA_DBS_STATUS_FULL.db"]=true;
    $files["/usr/share/artica-postfix/ressources/logs/web/cache/articatechdb.progress"]=true;
    $files["/usr/share/artica-postfix/ressources/logs/web/cache/toulouse.progress"]=true;
    $files["/usr/share/artica-postfix/ressources/logs/web/cache/webfilter-artica.progress"]=true;

    $files["/etc/artica-postfix/settings/Daemons/TLSEDbCloud"]=true;
    $files["/etc/artica-postfix/settings/Daemons/ArticaDbCloud"]=true;
    $files["/etc/artica-postfix/settings/Daemons/CurrentArticaDbCloud"]=true;
    $files["/etc/artica-postfix/settings/Daemons/CurrentTLSEDbCloud"]=true;
    $files["/usr/share/artica-postfix/ressources/logs/web/cache/webfilter-artica.progress"]=true;

    foreach ($files as $index=>$Directory){
        @unlink($index);
    }

    system("$php /usr/share/artica-postfix/exec.squidguard.php --build --force");
    if(is_file("/etc/init.d/ufdb")) {
        build_progress_delete("{restarting_service}", 90);
        system("/etc/init.d/ufdb restart --force");

    }

    build_progress_delete("{done}",100);
}
function stop($aspid=false){
    $LOGBIN="Categories Service";
    $unix=new unix();
    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $LOGBIN [STOP] Service Already Artica task running PID $pid since {$time}mn\n";}
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();


    if(!$unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service already stopped...\n";
        return true;
    }
    $pid=PID_NUM();

    echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service Shutdown pid $pid...\n";


    unix_system_kill($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        echo "Starting......: ".date("H:i:s")." [INIT]: $LOGBIN service waiting pid:$pid $i/5...\n";
        sleep(1);
    }

    $pid=PID_NUM();
    if(!$unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service success...\n";
        return true;
    }

    build_progress("{stopping_service} $pid ( force)",30);
    echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service shutdown - force - pid $pid...\n";
    unix_system_kill_force($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $LOGBIN service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    if(!$unix->process_exists($pid)){
        echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service success...\n";
        return true;
    }

    echo "Stopping......: ".date("H:i:s")." [INIT]: $LOGBIN service failed...\n";
    return false;

}

function PID_NUM(){

    $unix=new unix();
    $pid=$unix->get_pid_from_file("/var/run/dnscatz.pid");
    if($unix->process_exists($pid)){return $pid;}
    return $unix->PIDOF("/usr/sbin/dnscatz");

}