#!/usr/bin/php
<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.demime.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
if($argv[1]=="-v"){$GLOBALS["VERBOSE"]=true;ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}

xstart();


function xstart(){
    $unix=new unix();

    $pidfile="/home/mail2sms/mail2sms.pid";
    $pid=$unix->get_pid_from_file($pidfile);
    if($unix->process_exists($pid)){
        if($GLOBALS["VERBOSE"]){echo "$pid already running...\n";}
        die();
    }
    @unlink($pidfile);
    @file_put_contents($pidfile,getmypid());


    if(!is_file("/home/mail2sms/SQLITE/database.db")){
        if($GLOBALS["VERBOSE"]){echo "/home/mail2sms/SQLITE/database.db no such file\n";}
        die();}

    $q=new lib_sqlite("/home/mail2sms/SQLITE/database.db");
    $mail2smsMaxRetry=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsMaxRetry"));
    $mail2smsMaxLen=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsMaxLen"));
    if($mail2smsMaxLen==0){$mail2smsMaxLen=140;}
    $mail2smsRegex=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsRegex"));
    if($mail2smsRegex==null){$mail2smsRegex="^Mobile:(|\s+)(\+|00)([1-9][0-9 \-\(\)\.]{7,})$";}
    if($mail2smsMaxRetry==0){$mail2smsMaxRetry=5;}
    $mail2smsLocalNet=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsLocalNet"));

    $results=$q->QUERY_SQL("SELECT * FROM messages WHERE status<10 ORDER by sdate");
    if($GLOBALS["VERBOSE"]){echo count($results)." Rows to parse...\n";}

    foreach ($results as $index=>$ligne){
            $ID=$ligne["ID"];
            $sdate=$ligne["sdate"];
            $parsedate=$ligne["parsedate"];
            $ipaddr=$ligne["ipaddr"];
            $queueid=$ligne["queueid"];
            $retried=intval($ligne["retried"]);
            $phonenum=$ligne["phonenum"];
            $messageEncoded=$ligne["message"];
            $status=intval($ligne["status"]);
            $finaltext=trim($ligne["finaltext"]);
            $error=$ligne["error"];
            $fullmessage=DecodeMessage($messageEncoded);
            $smtpfrom=$ligne["smtpfrom"];
            $syspref="$queueid: from=<$smtpfrom> to=<$phonenum>, relay=mail2sms,";


            if(!Autorized($mail2smsLocalNet,$ipaddr)){
                $q->QUERY_SQL("UPDATE messages SET status=11,
                    `error`='$ipaddr not allowed' WHERE ID=$ID");
                MailSyslog("$syspref status=refused ('$ipaddr not allowed.)");
                continue;

            }

            if(!$fullmessage){
                $q->QUERY_SQL("UPDATE messages SET status=11,
                    `error`='Unable to unpack the message.' WHERE ID=$ID");
                MailSyslog("$syspref status=refused ('Unable to unpack the message.)");
                    continue;
            }

            if($phonenum==null){
                $phonenum=GetPhone($fullmessage,$mail2smsRegex);
                if(!$phonenum){
                    $q->QUERY_SQL("UPDATE messages SET status=11,
                    `error`='Unable to extract the Phone number.' WHERE ID=$ID");
                    MailSyslog("$syspref status=refused ('Unable to extract the Phone number.)");
                    continue;

                }
                $q->QUERY_SQL("UPDATE messages SET phonenum='$phonenum' WHERE ID=$ID");
            }

            if($finaltext==null){
                $finaltext=GetMessage($fullmessage,$mail2smsRegex,$mail2smsMaxLen);
                if(!$finaltext){
                        $q->QUERY_SQL("UPDATE messages SET status=11,
                    `error`='Unable to extract the final message.' WHERE ID=$ID");
                    MailSyslog("$syspref status=refused ('Unable to extract the final message)");
                    continue;
                }
                $q->QUERY_SQL("UPDATE messages SET finaltext='$finaltext' WHERE ID=$ID");

            }

            if(!PostMessage($ID,$phonenum,$finaltext,$queueid)){
                $retried++;
                if($retried>$mail2smsMaxRetry){
                    $q->QUERY_SQL("UPDATE messages SET status=11 WHERE ID=$ID");
                    MailSyslog("$syspref status=refused (max retry $retried)");
                    continue;

                }

                $q->QUERY_SQL("UPDATE messages SET retried=$retried WHERE ID=$ID");
                continue;
            }


            MailSyslog("$syspref status=sent (delivered via RestAPI)");
            $q->QUERY_SQL("DELETE FROM messages WHERE ID=$ID");

    }

    $netime=strtotime("-3 day");
    $q->QUERY_SQL("DELETE FROM messages WHERE sdate<$netime");
}

function Autorized($mail2smsLocalNet,$ipaddr){
    $mail2smsDebug=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsDebug"));

    $zips=explode(",",$mail2smsLocalNet);
    $IP=new IP();
    foreach ($zips as $zipok){
        $zipok=trim($zipok);
        if($zipok==null){continue;}
        if($mail2smsDebug==1){
            MailSyslog("Autorized:: Checking $ipaddr against $zipok");
        }

        if($ipaddr==$zipok){return true;}
        if(strpos($zipok,"/")>0){

            if($mail2smsDebug==1){
                MailSyslog("Autorized:: Checking $ipaddr against isInRange($zipok)");
            }

            if($IP->isInRange($ipaddr,$zipok)){
                return true;
            }
        }

    }

    return false;



}


function PostMessage($ID,$phonenum,$finaltext,$queueid){

    $mail2smsDebug=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsDebug"));

    $mail2smsHttpHeader=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpHeader"));
    $mail2smsHttpHeaderValue=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpHeaderValue"));
    $mail2smsHttpUrl=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpUrl"));
    $mail2smsHttpUseProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpUseProxy"));
    $mail2smsHttpProxy=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpProxy"));
    $mail2smsHttpProxyPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpProxyPort"));
    $mail2smsHttpSatusCode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsHttpSatusCode"));
    if($mail2smsHttpProxyPort==0){$mail2smsHttpProxyPort=3128;}
    if($mail2smsHttpSatusCode==0){$mail2smsHttpSatusCode=200;}
    $syspref="$queueid: to=<$phonenum>, relay=mail2sms,";

    $MAIN_URI =$mail2smsHttpUrl;

    $MAIN_URI=str_replace("%phone",$phonenum,$MAIN_URI);
    $MAIN_URI=str_replace("%content",$finaltext,$MAIN_URI);
    if($mail2smsDebug==1){
        MailSyslog("PostMessage: Initialize HTTP engine...");
    }
    $ch = curl_init($MAIN_URI);
    $CURLOPT_HTTPHEADER[]="Pragma: no-cache,must-revalidate";
    $CURLOPT_HTTPHEADER[]="Cache-Control: no-cache,must revalidate";
    $CURLOPT_HTTPHEADER[]="Expect:";
    if($mail2smsHttpHeader<>null) {
        $CURLOPT_HTTPHEADER[] = "$mail2smsHttpHeader: {$mail2smsHttpHeaderValue}";
    }

    curl_setopt($ch, CURLOPT_HTTPHEADER, $CURLOPT_HTTPHEADER);
    curl_setopt($ch, CURLOPT_TIMEOUT, 300);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    if(preg_match("#^https:#",$mail2smsHttpUrl)) {
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSLVERSION, 'all');
    }
    if($mail2smsHttpUseProxy==0) {
        curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, false);
        curl_setopt($ch, CURLOPT_NOPROXY, "*");
    }else {
        curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
        curl_setopt($ch, CURLOPT_PROXY, "$mail2smsHttpProxy:$mail2smsHttpProxyPort");
    }

    /*
     * If post... ? next release

    /$cFile = curl_file_create($filepath);
    $post = array('patch-artica' => 'yes','file_contents'=> $cFile);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    */
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);


    $response = curl_exec($ch);
    $json=json_decode($response);

    if($json){
        $errorDescription=null;
        MailSyslog("PostMessage: response is a json");
        if(property_exists($json,"errorCode")){
            $errorDescription="Error code ".$json->errorCode;
        }
        if(property_exists($json,"error")){
            $errorDescription=$errorDescription." ".$json->error;
        }
        if(property_exists($json,"errorDescription")){
            $errorDescription=$errorDescription."  ".$json->errorDescription;
        }
    }


    if($mail2smsDebug==1) {
        MailSyslog("PostMessage: $response");
    }

    if ($errno = curl_errno($ch)) {
        $errorMessage = curl_error($ch);
        MailSyslog("$syspref status=failed (Network Code: $errno $errorMessage)");
        $q=new lib_sqlite("/home/mail2sms/SQLITE/database.db");
        $q->QUERY_SQL("UPDATE messages SET status=0, `error`='err $errno $errorMessage' WHERE ID=$ID");
        if(!$q->ok){
            MailSyslog("$syspref $q->mysql_error");
        }
        return false;

    }

    $statusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

    if($mail2smsDebug==1) {
        MailSyslog("PostMessage: Status Code:  $statusCode");
    }

    if($statusCode==$mail2smsHttpSatusCode){
        return true;
    }



    MailSyslog("$syspref status=failed (HTTP Code: $statusCode $errorDescription)");

    $q=new lib_sqlite("/home/mail2sms/SQLITE/database.db");
    $q->QUERY_SQL("UPDATE messages SET status=0, `error`='HTTP Code: $statusCode $errorDescription' WHERE ID=$ID");
    if(!$q->ok){
        MailSyslog("$syspref $q->mysql_error");
    }
    return false;
}

function DecodeMessage($messageEncoded){
    $unix=new unix();
    $ftemp=$unix->FILE_TEMP();
    @file_put_contents($ftemp,base64_decode($messageEncoded));
    $demime=new demime($ftemp);
    if(!$demime->unpack(0)){return false;}
    return $demime->subject."\n".$demime->body."\n";
}
function GetMessage($msg,$regex,$maxlen){
    $tr=explode("\n",$msg);
    $newf=array();
    foreach ($tr as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#$regex#",$line,$re)){continue;}
        $newf[]=$line;
    }
    $data=@implode("\n",$newf);
    return substr($data,0,$maxlen);
}

function GetPhone($msg,$regex){
    $mail2smsDebug=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsDebug"));
    $tr=explode("\n",$msg);

    if($mail2smsDebug==1){
        MailSyslog("GetPhone:: Search $regex in ".count($tr)." lines");
    }


    foreach ($tr as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(!preg_match("#$regex#i",$line,$re)){continue;}
        unset($re[0]);
        MailSyslog("GetPhone:: $regex Found in \"$line\"");
        return trim(@implode("",$re));

    }
    return false;
}

function MailSyslog($text){

    if(function_exists("openlog")){openlog("postfix/mail2sms", LOG_PID , LOG_MAIL);}
    if(function_exists("syslog")){ syslog(LOG_INFO, $text);}
    if(function_exists("closelog")){closelog();}
}