<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.postgres.inc');
include_once(dirname(__FILE__).'/ressources/class.template-admin.inc');

if(preg_match("#--verbose#",implode(" ",$argv))){
    $GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;
    ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);
    ini_set('error_prepend_string',null);ini_set('error_append_string',null);
}

if($argv[1]=="--filed"){mode_security_file_to_time($argv[2]);exit;}
if($argv[1]=="--parse"){modsecurity_parsefile($argv[2]);exit;}
if($argv[1]=="--scan"){modsecurity_parse_first();exit;}


echo "Cannot understand ".@implode(" ",$argv) . "use --filed [filename],--parse [filepath] or --scan\n";
die();

function modsecurity_parse_first(){
    $unix=new unix();

    $pidpath="/var/run/ModSecurity/parser.pid";

    if(!is_dir("/var/run/ModSecurity")){
        @mkdir("/var/run/ModSecurity",0755,true);
    }
    $CurrentPid=$unix->get_pid_from_file($pidpath);
    if($unix->process_exists($CurrentPid)){
        events("Process $CurrentPid already exists: ".@file_get_contents("/proc/$CurrentPid/cmdline"));
        die();
    }
    $pid=getmypid();
    @unlink($pidpath);
    @file_put_contents($pidpath,$pid);


    if (!$handle = opendir("/home/artica/modsecurity")) {return;}
    while (false !== ($filename = readdir($handle))) {
        if ($filename == ".") {continue;}
        if ($filename == "..") {continue;}
        if(!preg_match("#^[0-9]+$#",$filename)){ events( "$filename no match (".__LINE__.")");continue;}
        $TargeDir = "/home/artica/modsecurity/$filename";
        if(!is_dir($TargeDir)){continue;}
        events( "Parsing $TargeDir");
        if(modsecurity_parse_second($TargeDir)){
            @rmdir($TargeDir);
        }
    }

}

function modsecurity_parse_second($TargeDir){
    $RETURN=true;
    if (!$handle = opendir($TargeDir)) {return;}
    while (false !== ($filename = readdir($handle))) {
        if ($filename == ".") {
            continue;
        }
        if ($filename == "..") {
            continue;
        }
        if (!preg_match("#^[0-9\-]+$#", $filename)) {
            events("$filename no match (".__LINE__.")");
            continue;
        }
        $TargeDir2 = "$TargeDir/$filename";
        if (!is_dir($TargeDir2)) {
            continue;
        }

        if(!modsecurity_parse_third($TargeDir2)){
            events("Parsing $TargeDir2 failed");
            $RETURN=false;
            continue;
        }
        events("Parsing $TargeDir2 true");
        rmdir($TargeDir2);

    }

    return $RETURN;
}
function modsecurity_parse_third($TargetDir){
    $RETURN=true;
    if (!$handle = opendir($TargetDir)) {return;}
    while (false !== ($filename = readdir($handle))) {
        if ($filename == ".") {
            continue;
        }
        if ($filename == "..") {
            continue;
        }
        if (!preg_match("#^[0-9\-\.]+$#", $filename)) {
            event("$filename no match (".__LINE__.")");
            continue;
        }
        $TargetFile = "$TargetDir/$filename";
        if (!is_file($TargetFile)) {
            events("$TargetFile not a file");
            continue;}

        if(!modsecurity_parsefile($TargetFile)){
            events( "Parsing $TargetFile true");
            $RETURN=false;
            continue;
        }
        events("Parsing $TargetFile true");
    }
    return $RETURN;
}

function modsecurity_parsefile($fullpath){

    $created=mode_security_file_to_time(basename($fullpath));

    if(!is_file($fullpath)){
        events("$fullpath no such file");
        return true;
    }
    if($GLOBALS["VERBOSE"]){events( "Open $fullpath");}
    $MAIN_CONTENT=@file_get_contents($fullpath);
    $f=explode("\n",$MAIN_CONTENT);
    $Array=array();

    foreach ($f as $line){
        if(!preg_match("#ModSecurity:\s+(.+)#i",$line,$re)){continue;}
        $Array=modesecurity_array($Array,$re[1]);
    }

    $q=new postgres_sql();
    if(!$q->create_modsecurity_tables()){
        events( "Unable to create modsecurity_tables $q->mysql_error");
        return false;
    }


    if(!isset($Array["unique_id"])){
        events( "Alert!, unique_id not found (".__LINE__.")");
        return false;
    }

    $unique_id=$Array["unique_id"];
    $unique_id=str_replace(".","",$unique_id);
    if(!is_numeric($unique_id)){
        events( "Alert {$Array["unique_id"]} -> $unique_id is not numeric (".__LINE__.")");
        return false;
    }

    $ruleid=$Array["id"];
    $severity=intval($Array["severity"]);
    $maturity=intval($Array["maturity"]);
    $accuracy=intval($Array["accuracy"]);

    if(!modsecurity_titles($ruleid,$Array["msg"])){
        events("Alert!, {$Array["msg"]} error (".__LINE__.")");
        return false;
    }

    $fileid=modsecurity_patterns($Array["file"]);
    if(!$fileid){
        events( "Error, cannot found the pattern id for {$Array["file"]} (".__LINE__.")");
        return false;
    }
    $versionid=modsecurity_vers($Array["ver"]);
    if(!$versionid){
        events( "Error, cannot found the version id for {$Array["ver"]} (".__LINE__.")");
        return false;
    }

    $hostid=modsecurity_hosts($Array["hostname"]);

    if(!$hostid){
        events( "Error, cannot found the version id for {$Array["hostname"]} (".__LINE__.")");
        return false;
    }

    $uriid=modsecurity_uris($Array["uri"]);

    if(!$uriid){
        events("Error, cannot found the version id for {$Array["uri"]} (".__LINE__.")");
        return false;
    }

    if(isset($Array["explain"])){
        $explainid=explain_id($Array["explain"]);
        if(!$explainid){
            events( "Error, cannot found the explain_id for {$Array["explain"]} (".__LINE__.")");
            return false;
        }
    }

    if(!modsecurity_reports($unique_id,$MAIN_CONTENT)){
        events( "Error, cannot add report for  {$unique_id} (".__LINE__.")");
        return false;
    }

    if(!modsecurity_tags($unique_id,$Array["TAGS"])){
        events( "Error, cannot add tags for  {$unique_id} (".__LINE__.")");
        return false;
    }

    $sql="INSERT INTO modsecurity_events( unique_id,created,fileid,ruleid,explainid,severity,versionid,maturity,accuracy,hostid,uriid) VALUES ($unique_id,'$created',$fileid,$ruleid,$explainid,$severity,$versionid,$maturity,$accuracy,$hostid,$uriid)";

    if($GLOBALS["VERBOSE"]){events("$sql (".__LINE__.")");}
    $q->QUERY_SQL($sql);

    if(!$q->ok){
        events($q->mysql_error);
        return false;
    }

    @unlink($fullpath);
    return true;
}

function modsecurity_tagid($tag){
    if(isset($GLOBALS["modsecurity_tagid"][$tag])){return $GLOBALS["modsecurity_tagid"][$tag];}
    $q=new postgres_sql();
    $q->QUERY_SQL("INSERT INTO modsecurity_tags (tag) VALUES ('$tag') ON CONFLICT DO NOTHING");
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_tags WHERE tag='$tag'");
    if(intval($ligne["id"])>0){
        $GLOBALS["modsecurity_tagid"][$tag]=$ligne["id"];
        return $ligne["id"];
    }
    return false;
}

function modsecurity_tags($unique_id,$tags){
    $q=new postgres_sql();

    if(!is_numeric($unique_id)){
        events( "Fatal '$unique_id' is not numeric (".__LINE__.")");
        return false;
    }
    if($unique_id==0){
        events("Fatal '$unique_id' is zero (".__LINE__.")");
        return false;
    }

    foreach ($tags as $key=>$none){
        $tagid=modsecurity_tagid($key);
        if(!$tagid){
            events("Fatal while get tag id of $key (".__LINE__.")");
            return false;
        }
        $q->QUERY_SQL("INSERT INTO modsecurity_linked_tags (tagid,ruleid) VALUES ('$tagid','$unique_id') ON CONFLICT DO NOTHING");
        if(!$q->ok){
            events($q->mysql_error);
            return false;
        }

    }

    return true;

}

function mode_security_file_to_time($basename){
    $td=explode("-",$basename);
    if(preg_match("#^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})#",$td[0],$re)){
        $Year=$re[1];
        $Month=$re[2];
        $Day=$re[3];
    }

    if(preg_match("#^([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})#",$td[1],$re)){
        $Hours=$re[1];
        $Mins=$re[2];
        $seconds=$re[3];
    }
    return "$Year-$Month-$Day $Hours:$Mins:$seconds";
}

function modsecurity_reports($unique_id,$content){
    $q=new postgres_sql();
    $content=base64_encode($content);
    if(intval($unique_id)==0){
       events("$unique_id is zero (".__LINE__.")");
        return false;
    }
    $q->QUERY_SQL("INSERT INTO modsecurity_reports (unique_id,content) VALUES ('$unique_id','$content') ON CONFLICT DO NOTHING");
    if(!$q->ok){
        events($q->mysql_error);
        return false;
    }
    return true;
}

function modsecurity_uris($uri){
    if(isset($GLOBALS["modsecurity_uris"][$uri])){return $GLOBALS["modsecurity_uris"][$uri];}

    $q=new postgres_sql();
    $q->QUERY_SQL("INSERT INTO modsecurity_uris(uri) VALUES ('$uri') ON CONFLICT DO NOTHING");
    if(!$q->ok){
        events($q->mysql_error);
       return false;
    }
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_uris WHERE uri='$uri'");

    if(!$q->ok){
        events($q->mysql_error);
        return false;
    }


    if(intval($ligne["id"])>0){
        $GLOBALS["modsecurity_uris"][$uri]=$ligne["id"];
        return $ligne["id"];
    }

    return false;
}

function modsecurity_hosts($ipaddr){
    if(isset($GLOBALS["modsecurity_hosts"][$ipaddr])){return $GLOBALS["modsecurity_hosts"][$ipaddr];}
    $tpl=new template_admin();
    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT id,threats FROM modsecurity_hosts WHERE ipaddr='$ipaddr'");
    if(intval($ligne["id"])==0){
        if(preg_match("#^[0-9\.]+#",$ipaddr)) {
            $hostname = $tpl->getHostByAddress($ipaddr);
        }else{
            $hostname=$ipaddr;
            $ipaddr=gethostbyname($hostname);
        }
        $threats=0;
        $q->QUERY_SQL("INSERT INTO modsecurity_hosts (ipaddr,hostname,threats) VALUES ('$ipaddr','$hostname','$threats') ON CONFLICT DO NOTHING");
        if(!$q->ok){
            events($q->mysql_error);
            return false;
        }
        $ligne=$q->mysqli_fetch_array("SELECT id,threats FROM modsecurity_hosts WHERE ipaddr='$ipaddr'");
    }

    if(intval($ligne["id"])>0){
        $id=intval($ligne["id"]);
        $threats=intval($ligne["threats"])+1;
        $q->QUERY_SQL("UPDATE modsecurity_hosts SET threats=$threats WHERE id=$id");
        $GLOBALS["modsecurity_hosts"][$ipaddr]=$id;
        return $id;
    }
    return false;
}

function modsecurity_vers($ver){
    if(isset($GLOBALS["modsecurity_vers"][$ver])){return $GLOBALS["modsecurity_vers"][$ver];}
    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_vers WHERE version='$ver'");
    if(intval($ligne["id"])==0){
        $q->QUERY_SQL("INSERT INTO modsecurity_vers (version) VALUES ('$ver') ON CONFLICT DO NOTHING");
        if(!$q->ok){
            events($q->mysql_error);
            return false;
        }
    }
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_vers WHERE version='$ver'");
    if(intval($ligne["id"])==0){
        return false;
    }
    $GLOBALS["modsecurity_vers"][$ver]=$ligne["id"];
    return $ligne["id"];
}

function modsecurity_patterns($file){
    if(isset($GLOBALS["modsecurity_patterns"][$file])){return $GLOBALS["modsecurity_patterns"][$file];}
    $file=basename($file);
    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_patterns WHERE filename='$file'");
    if(intval($ligne["id"])==0){
        $q->QUERY_SQL("INSERT INTO modsecurity_patterns (filename) VALUES ('$file') ON CONFLICT DO NOTHING");
        if(!$q->ok){
            events($q->mysql_error);
            return false;
        }
    }
    $ligne=$q->mysqli_fetch_array("SELECT id FROM modsecurity_patterns WHERE filename='$file'");
    if(intval($ligne["id"])==0){
        return false;
    }
    $GLOBALS["modsecurity_patterns"][$file]=$ligne["id"];
    return $ligne["id"];
}

function modsecurity_titles($ruleid,$msg){

    $q=new postgres_sql();

    $msg=str_replace("'","`",$msg);
    $q->QUERY_SQL("INSERT INTO modsecurity_titles (ruleid,msg)  VALUES ('$ruleid','$msg') ON CONFLICT DO NOTHING");
    if(!$q->ok){
        events($q->mysql_error);
        return false;
    }

    return true;
}

function explain_id($content){
    $md5=md5(trim($content));
    if(isset($GLOBALS["explain_id"][$md5])){return $GLOBALS["explain_id"][$md5];}
    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT id from modsecurity_explains WHERE zmd5='$md5'");
    if(intval($ligne["id"])==0){
        $contentbase=base64_encode($content);
        $q->QUERY_SQL("INSERT INTO modsecurity_explains (zmd5,report) VALUES ('$md5','$contentbase')");
        if(!$q->ok){events($q->mysql_error);return false;}
    }
    $ligne=$q->mysqli_fetch_array("SELECT id from modsecurity_explains WHERE zmd5='$md5'");
    if(intval($ligne["id"])==0){return false;}
    $GLOBALS["explain_id"][$md5]=intval($ligne["id"]);
    return intval($ligne["id"]);

}

function modesecurity_array($Array,$line){

    if(preg_match("#^(.+?)\[#",$line,$re)){
        $Subject=$re[1];
        $line=str_replace($Subject,"",$line);
    }

    $Array["explain"]=$Subject;


    if(preg_match_all("#\[(.+?)\]#",$line,$re)){
        foreach ($re[0] as $field){
            $field=trim($field);
            if(preg_match("#\[(.+?)\s+\"(.*?)\"#",$field,$ri)){
                $key=trim($ri[1]);
                $value=trim($ri[2]);
                if($key=="tag"){
                    $Array["TAGS"][$value]=true;
                    continue;
                }
                $Array[$key]=$value;
            }
        }
    }
return $Array;
}

function events($text){
    $filename=basename(__FILE__);
    $pid=getmypid();
    $date=date("H:i:s");
    $logFile="/var/log/modsec_parse.log";
    $size=filesize($logFile);
    if($size>1000000){unlink($logFile);}

    $f = @fopen($logFile, 'a');
    @fwrite($f, "$filename[$pid] $date $text\n");
    if($GLOBALS["VERBOSE"]){echo "$filename[$pid] $date $text\n";}
    @fclose($f);
}