#!/bin/bash
INPUT=/tmp/menu.sh.$$
OUTPUT=/tmp/output.sh.$$
trap "rm -f $OUTPUT >/dev/null 2>&1; rm -f $INPUT >/dev/null 2>&1; exit" SIGHUP SIGINT SIGTERM
DIALOG=${DIALOG=dialog}


function display_output(){
	local h=${1-10}			# box height default 10
	local w=${2-41} 		# box width default 41
	local t=${3-Output} 	# box title 
	dialog --backtitle "Menu console" --title "${t}" --clear --msgbox "$(<$OUTPUT)" ${h} ${w}
}
function BuilMasterConfig(){

    if [ ! -f /etc/artica-postfix/settings/Daemons/MasterDuplicateResetDHCP ]
    then
        echo 0 >/etc/artica-postfix/settings/Daemons/MasterDuplicateResetDHCP
    fi

    MasterDuplicateResetDHCP=`cat /etc/artica-postfix/settings/Daemons/MasterDuplicateResetDHCP`
    if [[ "$MasterDuplicateResetDHCP" == 1 ]];
    then
        echo 10 | /usr/bin/dialog --gauge "Reset networks and turn to DHCP..." 10 70 0
        sleep 1
        php /usr/share/artica-postfix/exec.autoconfig.php --reset-dhcp >/dev/null 2>&1
        sleep 1
    fi


	echo 20 | /usr/bin/dialog --gauge "Downloading auto-configuration file" 10 70 0
	sleep 1
	php /usr/share/artica-postfix/exec.autoconfig.php --download >/dev/null 2>&1
    sleep 1
    if [ ! -f /etc/artica-postfix/MASTER_STEP1 ]
    then
        /usr/bin/dialog --title "\Zb\Z1ERROR! ERROR!" --colors --infobox "\Zb\Z1Downloading the auto-configuration file failed!"  0 0
        sleep 6
        exit 0
    fi

	sleep 1
	echo 25 | /usr/bin/dialog --gauge "Decrypting auto-configuration file" 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --decrypt >/dev/null 2>&1
	sleep 1
	if [  -f /etc/artica-postfix/MASTER_DISABLED ]
    then
        /usr/bin/dialog --title "\Zb\Z1Master feature is disabled" --colors --infobox "\Zb\Z1The Master feature is disabled, skip this process"  0 0
        sleep 6
        echo 0 > /etc/artica-postfix/settings/Daemons/MasterDuplicateMode
        exit 0
    fi

    if [ ! -f /etc/artica-postfix/MASTER_STEP2 ]
    then
        PARMAS=`cat /etc/artica-postfix/MASTER_STEP2_ERROR` ||true
        /usr/bin/dialog --title "\Zb\Z1ERROR! ERROR!" --colors --infobox "\Zb\Z1Decrypting failed! $PARMAS"  0 0
        echo 0 > /etc/artica-postfix/settings/Daemons/MasterDuplicateMode
        sleep 6
        exit 0
    fi

    sleep 1
	echo 30 | /usr/bin/dialog --gauge "Reading configuration..." 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --read >/dev/null 2>&1
	sleep 1
    if [ ! -f /etc/artica-postfix/MASTER_STEP3 ]
    then
        PARMAS=`cat /etc/artica-postfix/MASTER_STEP2_ERROR` || true
        /usr/bin/dialog --title "\Zb\Z1ERROR! ERROR!" --colors --infobox "\Zb\Z1Parameters not found with $PARMAS"  0 0
        echo 0 > /etc/artica-postfix/settings/Daemons/MasterDuplicateMode
        sleep 6
        exit 0
    fi


    sleep 1
	echo 35 | /usr/bin/dialog --gauge "Checking Network..." 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --network >/dev/null 2>&1
	sleep 1
	echo 40 | /usr/bin/dialog --gauge "Reloading Network..." 10 70 0
	/etc/init.d/artica-ifup start >/dev/null 2>&1
	sleep 1


	echo 45 | /usr/bin/dialog --gauge "Checking License..." 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --license >/dev/null 2>&1
	sleep 1
    if [ ! -f /etc/artica-postfix/MASTER_LICENSE ]
    then
        PARMAS=`cat /etc/artica-postfix/MASTER_STEP2_ERROR` || true
        /usr/bin/dialog --title "\Zb\Z1ERROR! ERROR!" --colors --infobox "\Zb\Z1License not found with $PARMAS"  0 0
        echo 0 > /etc/artica-postfix/settings/Daemons/MasterDuplicateMode
        sleep 6
        exit 0
    fi



	echo 50 | /usr/bin/dialog --gauge "Checking Active Directory...." 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --adconnect >/dev/null 2>&1
    sleep 1
	echo 55 | /usr/bin/dialog --gauge "Checking Web-Filtering...." 10 70 0
	php /usr/share/artica-postfix/exec.autoconfig.php --ufdb >/dev/null 2>&1
	sleep 1
    echo 100 | /usr/bin/dialog --gauge "Success" 10 70 0
    echo 0 > /etc/artica-postfix/settings/Daemons/MasterDuplicateMode
    exit
}


function menu_network(){
 php /usr/share/artica-postfix/exec.menu.ips.php --network-menu
 /tmp/bash_network_menu.sh
}
function KeyBoard(){
 php /usr/share/artica-postfix/exec.menu.keyboard.php
/tmp/bash_keyboard_menu.sh
}

function Metap(){
  php /usr/share/artica-postfix/exec.menu.meta.php --menu
/tmp/bash_meta_menu.sh
}

function Statisticsp(){
  php /usr/share/artica-postfix/exec.menu.statistics.php --menu
  /tmp/bash_statistics_menu.sh
}



function htopp(){
/usr/bin/htop
}

function WebInterfacep(){
 php /usr/share/artica-postfix/exec.menu.apache.php --menu
/tmp/bash_apache_menu.sh
}

function License(){
 php /usr/share/artica-postfix/exec.menu.license.php --menu
/tmp/bash_license_menu.sh
}

function Systemp(){
chmod 0755 /usr/share/artica-postfix/logon.system.sh
/usr/share/artica-postfix/logon.system.sh
}

if [ -f /etc/artica-postfix/settings/Daemons/MasterDuplicateMode ]
then
    MasterDuplicateMode=`cat /etc/artica-postfix/settings/Daemons/MasterDuplicateMode`
    if [[ "$MasterDuplicateMode" == 1 ]];
    then
        BuilMasterConfig
        exit 0
    fi
fi

    echo 35 | /usr/bin/dialog --gauge "Checking Version..." 10 70 0
    ARTICAVERSION=`cat /usr/share/artica-postfix/VERSION`
    echo 36 | /usr/bin/dialog --gauge "Checking Version [$ARTICAVERSION]..." 10 70 0
    sleep 1
    echo 37 | /usr/bin/dialog --gauge "Checking Network..." 10 70 0
    IPs=`php /usr/share/artica-postfix/exec.menu.ips.php`




    echo 100 | /usr/bin/dialog --gauge "Done..." 10 70 0



while true
do

    if [ -f /etc/artica-postfix/.lockC ]
        then
            pass1=$(dialog --title "Password to unlock console" --clear --insecure --passwordbox "Enter your password" 10 50 3>&1- 1>&2- 2>&3-)
            ret=$?
            case $ret in
                0)

                    pass2=`cat /etc/artica-postfix/.lockC`

                    if [ "$pass1" != "$pass2" ]
                        then
                            continue
                        fi

                 ;;
                1) continue;;
                255) continue;;
            esac
        fi




$DIALOG --clear  --nocancel --backtitle "Firmware version $ARTICAVERSION on $HOSTNAME" \
--title "[ M A I N - M E N U ]" \
--menu "$IPs\\nYou can use the UP/DOWN arrow keys\nChoose the TASK" 25 100 11 \
Network "Modify server Network configuration" \
System "Root password and system tasks" \
KeyBoard "Keyboard,local,charset setup" \
Processes "Processes Monitor" \
WebInterface "Web console menu" \
License "License Info" \
Reboot "Reboot this server" \
Shutdown "Shutdown this server" \
Exit "Exit to the shell" 2>"${INPUT}"
 
menuitem=$(<"${INPUT}")

case $menuitem in
	Network) menu_network;;
	Processes) htopp;;
	System) Systemp;;
	WebInterface) WebInterfacep;;
	Statistics) Statisticsp;;
	Meta) Metap;;
	Reboot) reboot;;
	KeyBoard) KeyBoard;;
	License) License;;
	Shutdown) init 0;;
	Exit) /bin/login.old;;
esac
 
done
 
# if temp files found, delete em
if [ -f $OUTPUT ]
 then
    rm $OUTPUT >/dev/null 2>&1
fi
if [ -f $INPUT ]
 then
    rm $INPUT >/dev/null 2>&1
fi
