<?php
include_once(dirname(__FILE__)."/class.memcached.inc");
require_once '/usr/share/artica-postfix/ressources/externals/GeoIP2/vendor/autoload.php';
use GeoIp2\Database\Reader;

class lib_track_user{
	
	var $memcached;
	var $WLOGExists=1;
	public $CountryName=null;
	private $PHP_GEOIP_INSTALLED=0;
	private $EnableGeoipUpdate=0;
	private $ProxyDenyCountries=0;
	
	function __construct(){
		$this->memcached=new lib_memcached();
        $this->PHP_GEOIP_INSTALLED    = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PHP_GEOIP_INSTALLED"));
        $this->EnableGeoipUpdate      = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableGeoipUpdate"));
        $this->ProxyDenyCountries     = unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ProxyDenyCountries")));
	
	}
	
	
	function SetHit($user){
		$MyCurrentTime=date("YmdH");
		$value=unserialize($this->memcached->getKey("SquidLicenseUsers"));
		if(!isset($value["SquidLicenseUsersMaxFound"])){$value["SquidLicenseUsersMaxFound"]=0;}
		if(!$this->memcached->ok){$this->events("SetHit:".__LINE__.": getKey(SquidLicenseUsers): MemCached Error {$this->memcached->mysql_error}");}
		
		$value[$MyCurrentTime]["USERS"][$user]=1;
		$COuntOfValue=count($value);
		$CountOFUsers=count($value[$MyCurrentTime]["USERS"]);
		$this->events("SetHit:".__LINE__.": $COuntOfValue rows {$CountOFUsers} users");

		$SquidLicenseUsersMaxFound=intval($value["SquidLicenseUsersMaxFound"]);
        $this->events("SetHit:".__LINE__.": SquidLicenseUsersMaxFound == $SquidLicenseUsersMaxFound");
		if($CountOFUsers>$SquidLicenseUsersMaxFound){
            $this->events("SetHit:".__LINE__.": SquidLicenseUsersMaxFound ==> $CountOFUsers");
            $value["SquidLicenseUsersMaxFound"]=$CountOFUsers;

        }

		
		if($COuntOfValue>3){
			
		
			foreach ($value as $CurrentTime=>$array){
			    if($CurrentTime=="SquidLicenseUsersMaxFound"){continue;}
				
				if($CurrentTime==$MyCurrentTime){
					$this->events("SetHit:".__LINE__.": Skip $CurrentTime");
					continue;
				}
				unset($value[$CurrentTime]);
				
			}
		}
		
		
		$this->memcached->saveKey("SquidLicenseUsers",serialize($value));
		if(!$this->memcached->ok){$this->events("SetHit:".__LINE__.": saveKey: MemCached Error {$this->memcached->mysql_error}");}
		
		
		
	}
	
	private function events($text){
		if($this->WLOGExists==1){
			if(!function_exists("WLOG")){$this->WLOGExists=0;}
			$this->WLOGExists=3;
		}
		if($this->WLOGExists==3){
			WLOG("lib_track_user: $text",true);
		}
	}
	
	
	function UserAliases($macAddr,$ipaddr){
		
		
		if($macAddr<>null){
			$Alias=$this->memcached->getKey("$macAddr:alias");
			if(!$this->memcached->ok){$this->events("UserAliases:".__LINE__.": getKey($macAddr:alias): MemCached Error {$this->memcached->mysql_error}");}
			
			
			if($this->memcached->MemCachedFound){
				$this->events("UserAliases: HIT ".__LINE__.": $macAddr == $Alias ( From Memcached)");
				
				if($Alias=="NONE"){
					$this->events("UserAliases: HIT ".__LINE__.": Return NULL");
					return null;
				}
				$this->events("UserAliases: HIT ".__LINE__.": $macAddr return  $Alias ( From MEMOR)");
				return $Alias;
			}else{
				$this->events("UserAliases: MISS ".__LINE__.": $macAddr:alias");
			}
				
				
			if(is_file("/home/artica/UsersMac/Caches/$macAddr")){
				$tb=explode("|",@file_get_contents("/home/artica/UsersMac/Caches/$macAddr"));
				$this->events("UserAliases:".__LINE__.": saveKey($macAddr:alias) -> {$tb[0]}");
				$this->memcached->saveKey("$macAddr:alias", $tb[0],600);
				if(!$this->memcached->ok){$this->events("UserAliases:".__LINE__.": saveKey($macAddr:alias) -> '{$tb[0]}' MemCached Error {$this->memcached->mysql_error}");}
				return $tb[0];
				
			}
			
			$this->events("UserAliases:".__LINE__.": saveKey($macAddr:alias) -> NONE");
			$this->memcached->saveKey("$macAddr:alias", "NONE",600);
			if(!$this->memcached->ok){$this->events("UserAliases:".__LINE__.": saveKey($macAddr:alias): MemCached Error {$this->memcached->mysql_error}");}
		}
		
		$Alias=$this->memcached->getKey("$ipaddr:alias");
		if($this->memcached->MemCachedFound){return $Alias;}
		
		if(is_file("/home/artica/UsersMac/Caches/$ipaddr")){
			$tb=explode("|",@file_get_contents("/home/artica/UsersMac/Caches/$ipaddr"));
			$this->memcached->saveKey("$macAddr:alias", $tb[0],600);
			return $tb[0];
		}
		
		$this->memcached->saveKey("$ipaddr:alias", "",600);
			
		
	}


    private function DenyByGeoIPSyslog($text){

	    if(!function_exists("openlog")){return false;}
        if(!function_exists("syslog")){return false;}

        $LOG_SEV=LOG_INFO;
        if(function_exists("openlog")){openlog("proxy_geoip", LOG_PID , LOG_SYSLOG);}
        if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
        if(function_exists("closelog")){closelog();}
    }

	public function DenyByGeoIP($ipadddr){
        $CACHE="HIT";
        if($this->ProxyDenyCountries==0){return false;}

        if($this->PHP_GEOIP_INSTALLED==0){
            $this->DenyByGeoIPSyslog("[WARNING]: [$ipadddr] PHP_GEOIP_INSTALLED return 0");
            return false;
        }
        if($this->EnableGeoipUpdate==0){
            $this->DenyByGeoIPSyslog("[WARNING]: [$ipadddr] GeoIPUpdate return not installed");
            return false;
        }
        if (!extension_loaded("maxminddb")) {
            $this->DenyByGeoIPSyslog("[WARNING]: [$ipadddr] maxminddb module not installed");
            return false;
        }

        if(!isset($GLOBALS["ProxyDenyCountries"])){
            $GLOBALS["ProxyDenyCountries"]=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ProxyDenyCountries")));
            if(!is_array($GLOBALS["ProxyDenyCountries"])){$GLOBALS["ProxyDenyCountries"]=array();}
        }

        $ProxyDenyCountries=$GLOBALS["ProxyDenyCountries"];

        if(count($ProxyDenyCountries)==0){
            $this->DenyByGeoIPSyslog("[INACTIVE]: [$ipadddr] No denied country has been defined");
            return false;
        }

        $value=unserialize($this->memcached->getKey("GEOIP:$ipadddr"));
        if(!is_array($value)){$value=array();}

        if(!isset($value["countryCode"])) {
            try {
                $CACHE="MISS";
                $reader = new Reader('/usr/local/share/GeoIP/GeoLite2-Country.mmdb');
                $record = $reader->country($ipadddr);
                $value["countryCode"] = $record->country->isoCode;
                $value["countryName"] = $record->country->name;
                $this->memcached->saveKey("GEOIP:$ipadddr",serialize($value),16000);
            } catch (Exception $e) {
                $this->DenyByGeoIPSyslog("[FATAL]: [$ipadddr] " . $e->getMessage());
                return false;
            }
        }


        if ($value["countryCode"] == null) {
            $this->DenyByGeoIPSyslog("[INACTIVE]: [$ipadddr] Unknown (unknown)");
            return false;
        }
        $countryCode=$value["countryCode"];
        $countryName=$value["countryName"];

        if(isset($ProxyDenyCountries[$countryCode])){
            $this->DenyByGeoIPSyslog("[DENY]: [$ipadddr] $countryCode ($countryName) - $CACHE");
            $this->CountryName=$countryName;
            return true;
        }
        $this->DenyByGeoIPSyslog("[PASS]: [$ipadddr] $countryCode ($countryName) - $CACHE");

        return false;


    }
	
	function ufdbunlock($FAMILYSITE,$uid=null,$ipaddr=null){
		$FAMILYSITE=trim(strtolower($FAMILYSITE));
		$uid=trim(strtolower($uid));
		$ipaddr=trim(strtolower($ipaddr));
        $results=null;
		$ufdbunlock_value=$this->memcached->getKey("ufdbunlock");
		if($this->memcached->MemCachedFound){
			$results=@unserialize($ufdbunlock_value);
			if(!$results){$results=null;}
		}
		
		if(!is_array($results)){
			$q=new lib_sqlite("/home/artica/SQLITE/webfilter.db");
			$sql="SELECT finaltime,uid,ipaddr,www FROM ufdbunlock WHERE finaltime >".time();
			$results=$q->QUERY_SQL($sql);
			$this->memcached->saveKey("ufdbunlock", $results);
		}
		
		$time=time();
		foreach ($results as $index=>$ligne){
			$finaltime=$ligne["finaltime"];
			$www=trim(strtolower($ligne["www"]));
			$db_uid=trim(strtolower($ligne["uid"]));
			$db_ipaddr=trim(strtolower($ligne["ipaddr"]));
			if($db_uid=="unknown"){$db_uid=null;}
			if($time>$finaltime){continue;}
			if($www<>$FAMILYSITE){continue;}
			if($db_uid<>null){ if($uid==$db_uid){return true;} }
			if($db_ipaddr<>null){ if($db_ipaddr == $ipaddr){return true;} }
		}
		
		
	}
	
	
	function isWhitelisted($sitename){
	    $sitename=strtolower($sitename);
        $default["ipinfo.io"]=true;
	    $default["github.hubspot.com"]=true;
	    $default["in.appcenter.ms"]=true;
        $default["cdn.smehost.net"]=true;
        $default["display.ugc.bazaarvoice.com"]=true;
	    $default["googletagmanager.com"]=true;
        $default["www.googletagmanager.com"]=true;
		$default["highcharts.com"]=true;
		$default["amazonaws.com"]=true;
		$default["orange.fr"]=true;
		$default["salesforce.com"]=true;
		$default["force.com"]=true;
		$default["akamaihd.net"]=true;
		$default["nvidia.com"]=true;
		$default["wistia.net"]=true;
		$default["ebay.com"]=true;
		$default["jqueryscript.net"]=true;
		$default["microsoft.com"]=true;
		$default["fnac.com"]=true;
		$default["abtasty.com"]=true;
		$default["adobedtm.com"]=true;
        $default["hubvisor.io"]=true;
        $default["01net.com"]=true;
        $default["yandex.ru"]=true;
        $default["netdna-ssl.com"]=true;
        $default["sfr.fr"]=true;
        $default["google.com"]=true;
        $default["cloudfront.net"]=true;
        $default["game-mode.net"]=true;
        $default["gvt1.com"]=true;
        $default["gvt2.com"]=true;
        $default["gvt3.com"]=true;
        $default["gvt4.com"]=true;
        $default["gvt5.com"]=true;
        $default["ipify.org"]=true;
        $default["maxmind.com"]=true;
        $default["bing.com"]=true;
        $default["wix.com"]=true;
        $default["cdn.woopic.com"]=true;
        $default["woopic.com"]=true;
        $default["spiceworks.com"]=true;
		if(isset($default[$sitename])){return true;}







		$precache=$this->memcached->getKey("isWhite:$sitename");
		if($this->memcached->MemCachedFound){
			$this->events("isWhitelisted: HIT ".__LINE__.": isWhite:$sitename");
			return $precache;
		}
		
		$acls_whitelist_domains=$this->memcached->getKey("acls_whitelist_domains");
		if(!is_array($acls_whitelist_domains)){
			$f=explode("\n",@file_get_contents("/etc/squid3/acls_whitelist.dstdomain.conf"));
			foreach ($f as $line){
				$line=trim(strtolower($line));
                $line=str_replace("^","",$line);
				if(strlen($line)<4){continue;}
				if(substr($line,0,1)=="."){$line=substr($line, 1,strlen($line));}
				$line=trim($line);
				$default[$line]=true;
                $this->memcached->saveKey("isWhite:$line",true,300);
			}
			
			$this->events("isWhitelisted: MISS ".__LINE__.": saveKey(acls_whitelist_domains)");
			$this->memcached->saveKey("acls_whitelist_domains", $default,300);
			
			
		}else{
			$this->events("isWhitelisted: HIT ".__LINE__.": $sitename");
		}
		
		if(isset($acls_whitelist_domains[$sitename])){
			$this->memcached->saveKey("isWhite:$sitename", true,300);
			return true;
		}else{
			$this->memcached->saveKey("isWhite:$sitename", false,300);
		}
	}
	
	function CheckNoTracks($WEBSITE,$FAMILYSITE=null){
        $WEBSITE=strtolower(trim($WEBSITE));
        $FAMILYSITE=strtolower(trim($FAMILYSITE));

        if($this->isWhitelisted($WEBSITE)){
            return false;
        }
        if($FAMILYSITE<>null){
            $FAMILYSITE=strtolower($FAMILYSITE);
            if($this->isWhitelisted($FAMILYSITE)){
                return false;
            }
        }

        $MEM["an.yandex.ru"]=true;
        $MEM["rotator.admediator.ru"]=true;
        $MEM["mdetectlog.manageo.fr"]=true;
        $MEM["apps.nexus.bazaarvoice.com"]=true;
        $MEM["ugc.bazaarvoice.com"]=true;
        $MEM["reviews.bazaarvoice.com"]=true;
        $MEM["analyzer.wox.cc"]=True;
        $MEM["api.ipdata.co"]=True;
        $MEM["counter.wox.cc"]=True;
        $MEM["d41.co"]=True;
        $MEM["ganon.yahoo.com"]=True;
        $MEM["r.mail.ru"]=True;
        $MEM["abeagle-public.buzzfeed.com"]=True;
        $MEM["analytics.agoda.com"]=True;
        $MEM["analytics.eip.telegraph.co.uk"]=True;
        $MEM["analytics.nike.com"]=True;
        $MEM["anon-stats.eff.org"]=True;
        $MEM["astat.nikkei.com"]=True;
        $MEM["log.gifmagazine.net"]=True;
        $MEM["metrics-logger.spot.im"]=True;
        $MEM["smetrics.aem.playstation.com"]=True;
        $MEM["smetrics.cnn.com"]=True;
        $MEM["smetrics.consumerreports.org"]=True;
        $MEM["smetrics.telegraph.co.uk"]=True;
        $MEM["sstats.adobe.com"]=True;
        $MEM["sstats.bitdefender.com"]=True;
        $MEM["targetemsecure.blob.core.windows.net"]=True;
        $MEM["targeting.washpost.nile.works"]=True;
        $MEM["mc.yandex.ru"]=true;
        $MEM["tracker.prod.reelevant.dev"]=true;
        $MEM["src.leadistic.com"]=true;
        if(isset($MEM[$WEBSITE])){return true;}




        if($FAMILYSITE==$WEBSITE){$FAMILYSITE=null;}

		$value=$this->memcached->getKey("notrack:$WEBSITE");

		if($this->memcached->MemCachedFound){
            if($GLOBALS["VERBOSE"]){
                if($value){
                    echo "notrack:$WEBSITE -> True\n";
                }else{
                    echo "notrack:$WEBSITE -> False\n";
                }
            }

		    return $value;}

		if($FAMILYSITE<>null) {
            $value = $this->memcached->getKey("notrack:$FAMILYSITE");
            if ($this->memcached->MemCachedFound) {
                if($GLOBALS["VERBOSE"]){
                    if($value){
                        echo "notrack:$FAMILYSITE -> True\n";
                    }else{
                        echo "notrack:$FAMILYSITE -> False\n";
                    }
                }
                return $value;
            }
        }

		if(is_file("/etc/squid3/NoTrack.db")) {
            $db_con = @dba_open("/etc/squid3/NoTrack.db", "r", "db4");
            if($db_con) {
                $data = intval(dba_fetch($WEBSITE, $db_con));

                if ($GLOBALS["VERBOSE"]) {
                    "Fetch $WEBSITE data=$data\n";
                }

                if ($data == 1) {
                    $this->memcached->saveKey("notrack:$WEBSITE", true, 3600);
                    return true;
                }

                if ($FAMILYSITE <> null) {
                    $data = intval(dba_fetch($FAMILYSITE, $db_con));
                    if ($data == 1) {
                        $this->memcached->saveKey("notrack:$FAMILYSITE", true, 3600);
                        return true;
                    }

                }
            }
        }

        $this->memcached->saveKey("notrack:$WEBSITE", false, 3600);
        return false;
	}
	
	function CheckUrlHaus($url){
		$value=strtolower(trim($url));
		$md5=md5($value);
		$this->events("CheckUrlHaus:".__LINE__.": getKey(UrlHaus:$md5)");
		$value=$this->memcached->getKey("UrlHaus:$md5");
		if($this->memcached->MemCachedFound){
			$value=$this->bool($value);
			if($value){
				$this->events("CheckUrlHaus:".__LINE__.": HIT (true)");
				return true;
			}else{
				$this->events("CheckUrlHaus:".__LINE__.": HIT (false)");
				return false;
			}
			
		}
		$db_path="/etc/squid3/UrlHaus.db";
		$db_con = @dba_open($db_path, "r","db4");
		
		$this->events("CheckUrlHaus:".__LINE__.": dba_fetch($md5)");
		$data=dba_fetch($md5,$db_con);
		if($data==1){
			$this->events("CheckUrlHaus:".__LINE__.": saveKey(UrlHaus:$md5,true) For 600s");
			$this->memcached->saveKey("UrlHaus:$md5", "true",3600);
			$this->events("CheckUrlHaus:".__LINE__.": MISS (true)");
			return true;
		}
		$this->events("CheckUrlHaus:".__LINE__.": saveKey(UrlHaus:$md5,false) For 600s");
		$this->memcached->saveKey("UrlHaus:$md5", "false",600);
		$this->events("CheckUrlHaus:".__LINE__.": MISS (false)");
	}
	
	
	private function bool($var) {
		switch (strtolower($var)) {
			case ("true"):return true;break;
			case ("false"):return false;break;
			case("1"):return true;break;
			case("0"):return true;break;
			default:
				return false;
		}
	}
	
	
	
	private function tool_time_min($timeFrom){
		$data1 = $timeFrom;
		$data2 = time();
		$difference = ($data2 - $data1);
		$results=intval(round($difference/60));
		if($results<0){$results=1;}
		return $results;
	}
	
	
	
	
}