<?php
include_once(dirname(__FILE__)."/class.modsecurity.inc");


function ifFrontEndSSL($SERVICE_ID) {
    $nginxsock = new socksngix($SERVICE_ID);
    $ssl_certificate=$nginxsock->GET_INFO("ssl_certificate");
    if($ssl_certificate==null){return false;}

    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");

    $results=$q->QUERY_SQL("SELECT * FROM stream_ports WHERE serviceid='$SERVICE_ID'");
    foreach ($results as $index=>$ligne){
        $options=unserialize(base64_decode($ligne["options"]));
        $ssl=intval($options["ssl"]);
        if($ssl==1){return true;}
    }

}

function build_httpreverse($MASTER_LINE,$SERVICE_ID,$DEFAULT_SERVER=false){
    $unix                   = new unix();
    $outgoingaddr           = null;
    $AS_SSL                 = ifFrontEndSSL($SERVICE_ID);
    $NginxHTTPModSecurity   = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NginxHTTPModSecurity"));
    $servicename            = $MASTER_LINE["servicename"];
    $zorder                 = intval($MASTER_LINE["zorder"]);
    $q                      = new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $nginxsock              = new socksngix(0);
    $sock                   = new socksngix($SERVICE_ID);

    $proxy_cache_valid_default=intval($nginxsock->GET_INFO("proxy_cache_valid_default"));
    if($proxy_cache_valid_default==0){$proxy_cache_valid_default=720;}


    $NginxHTTPSubModule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NginxHTTPSubModule"));
    $mainpath="/etc/nginx/reverse.d/$zorder-$SERVICE_ID.conf";
    echo "build_httpreverse: $servicename path........: $mainpath\n";




    $upstream_file="/etc/nginx/backends.d/$zorder-$SERVICE_ID.conf";
    $UPS[]="upstream backends{$SERVICE_ID} {";
    $UPS[]="\tleast_conn;";
    $results=$q->QUERY_SQL("SELECT * FROM backends WHERE serviceid='$SERVICE_ID'");
    foreach ($results as $md5=>$ligne){
        $hostname=$ligne["hostname"];
        $port=$ligne["port"];
        $f[]="# Backend: $hostname:$port";
        $UPS[]="\tserver $hostname:$port;";

    }

    $UPS[]="}";
    @file_put_contents($upstream_file, @implode("\n", $UPS));

    $EnableModSecurity=intval($sock->GET_INFO("EnableModSecurity"));
    if($NginxHTTPModSecurity==0){$EnableModSecurity=0;}
    $HostHeader=trim($sock->GET_INFO("HostHeader"));
    $proxy_http_version=$sock->GET_INFO("proxy_http_version");
    $Redirect80To443=$sock->GET_INFO("Redirect80To443");
    if($proxy_http_version==null){$proxy_http_version="1.0";}
    $limit_conn=intval($sock->GET_INFO("limit_conn"));
    $proxy_download_rate=intval($sock->GET_INFO("proxy_download_rate"));
    $proxy_upload_rate=intval($sock->GET_INFO("proxy_upload_rate"));
    $proxy_bind=$sock->GET_INFO("proxy_bind");
    if($proxy_bind<>null){$outgoingaddr=$unix->InterfaceToIPv4($proxy_bind);}
    $ssl_directives=ssl_directives($SERVICE_ID);
    $CERTIFICATE_ENABLED=$GLOBALS["CERTIFICATE_ENABLED"];
    $cache_erverything = intval($sock->GET_INFO("cache_erverything"));



    $SSL=false;
    $http_proto="http";
    if(intval($sock->GET_INFO("UseSSL"))==1){$SSL=true;$http_proto="https"; }


    $t_gz[]="\tgzip on;";
    $t_gz[]="\tgzip_min_length 10240;";
    $t_gz[]="\tgzip_types text/plain text/css text/xml text/javascript application/x-javascript application/xml;";
    $t_gz[]="\tgzip_disable \"MSIE [1-6]\.\";";
    $t_gz[]="\tadd_header X-Content-Type-Options nosniff;";
    $t_gz[]="\tadd_header X-XSS-Protection \"1; mode=block\";";
   // $t_gz[]="\tadd_header Content-Security-Policy \"default-src 'self'; script-src 'self' 'unsafe-inline' 'unsafe-eval' https://ssl.google-analytics.com https://assets.zendesk.com https://connect.facebook.net; img-src 'self' https://ssl.google-analytics.com https://s-static.ak.facebook.com https://assets.zendesk.com; style-src 'self' 'unsafe-inline' https://fonts.googleapis.com https://assets.zendesk.com; font-src 'self' https://themes.googleusercontent.com; frame-src https://assets.zendesk.com https://www.facebook.com https://s-static.ak.facebook.com https://tautt.zendesk.com; object-src 'none'\";";
    $gzip=@implode("\n",$t_gz);


    $proxy_pass="{$http_proto}://backends{$SERVICE_ID}";



     $f[]="# NginxHTTPSubModule = $NginxHTTPSubModule;";
    $f_stub=array();
    if($NginxHTTPSubModule==1) {
        $HostHeaderReplace = intval($sock->GET_INFO("HostHeaderReplace"));
        $ProtoReplaceContent = intval($sock->GET_INFO("ProtoReplaceContent"));
        if ($HostHeaderReplace == 1) {
            if ($HostHeader <> null) {
                if($ProtoReplaceContent==1){
                    $f_stub[] = "\tsub_filter '$HostHeader'  '\$host';";
                    if($AS_SSL) {
                        $f_stub[] = "\tsub_filter 'http://'  'https://';";
                    }
                    $f_stub[] = "\tsub_filter 'http%3A%2F%2F$HostHeader' 'https%3A%2F%2F\$host';";
                }else {
                    $f_stub[] = "\tsub_filter '$HostHeader'  \$host;";
                    $f_stub[] = "\tsub_filter 'http%3A%2F%2F$HostHeader' '%3A%2F%2F\$host';";
                }


               // $f_stub[] = "\tsub_filter '<head>' '<head><meta http-equiv=\"Content-Security-Policy\" content=\"default-src https:\">';";
                $f_stub[] = "\tsub_filter_once off;";
                $f_stub[] = "\tsub_filter_types *;";
            }
        }
    }

    $stubmodule=@implode("\n",$f_stub);
    $cache_directives=cache_directives($SERVICE_ID,$proxy_pass,$stubmodule);


    if($Redirect80To443==1){
        $default80=null;
        if($DEFAULT_SERVER){$default80=" default_server";}
        $f[]="server {";
        $f[]="  listen 80{$default80};";
        $f[]=buildservernames($MASTER_LINE);
        $f[]="  return 301 https://\$host\$request_uri;";
        $f[]="}\n\n\n";
    }



    $f[]="server {";
    if($NginxHTTPModSecurity==1){
        $f[] = "#\t Web application Firewall";
        if($EnableModSecurity==1) {
            $modsecurities_file = "/etc/nginx/modsecurities/loader.conf";
            $f[] = "\tmodsecurity on;";
            $f[] = "\tmodsecurity_rules_file $modsecurities_file;";
            $f[] = "\tSecWebAppId \"$SERVICE_ID\";";
        }else{
            $f[] = "\tmodsecurity off;";
        }
        $f[] = "";
    }



    $f[]=listen_port_directive($SERVICE_ID, $CERTIFICATE_ENABLED,$DEFAULT_SERVER);
    $f[]=buildservernames($MASTER_LINE);
    if($limit_conn>0){
        $f[]="\tlimit_conn\taddr {$limit_conn};";
        $f[]="\tlimit_conn_log_level error;";
    }

    if($proxy_download_rate>0){$f[]="\tproxy_download_rate {$proxy_download_rate}k;";}
    if($proxy_upload_rate>0){$f[]="\tproxy_upload_rate {$proxy_upload_rate}k;";}
    if($outgoingaddr<>null){$f[]="\tproxy_bind $outgoingaddr;";}
    $f[]="#----------------------- ACCESS RULES";
    $f[]=ngx_stream_access_module($SERVICE_ID);
    $f[]="#";
    $f[]="#";
    $f[]="#----------------------- SSL Directives";
    $f[]=$ssl_directives;
    $f[]=$cache_directives;
    $f[]="#";





    if($cache_erverything==1){
        $proxy_d[]="\tproxy_cache bigcache;";
        $proxy_d[]="\tproxy_cache_valid any {$proxy_cache_valid_default}m;";
        $proxy_d[]="\tadd_header X-Proxy-Cache \$upstream_cache_status;";

    }



    $proxy_d[]="\tproxy_pass $proxy_pass;";
    $proxy_d[]="\tproxy_http_version $proxy_http_version;";
    $proxy_d[]="\tproxy_set_header Connection \"\";";
    if($HostHeader<>null){$proxy_d[]="\tproxy_set_header Host $HostHeader;";}
    if($HostHeader==null){$proxy_d[]="\tproxy_set_header Host \$host;";}
    $proxy_d[]="\tproxy_set_header X-Real-IP \$remote_addr;";
    $proxy_d[]="\tproxy_set_header X-Forwarded-For \$remote_addr;";
    $proxy_d[]="\tproxy_set_header Accept-Encoding \"\";";
    if($AS_SSL){
        $proxy_d[]="\tadd_header Strict-Transport-Security \"max-age=31536000; includeSubDomains\" always;";

    }


    if($SSL){
        $proxy_d[]="\tproxy_set_header X-Forwarded-Proto https;";
        $proxy_d[]="\tproxy_redirect http:// https://;";
    }else{
        $proxy_d[]="\tproxy_redirect http://$HostHeader/ /;";
    }

    $proxy_directives="$stubmodule\n$gzip\n".@implode("\n",$proxy_d);

//-------------------------------------------------------------------------------------------------------------------------------------
    $results=$q->QUERY_SQL("SELECT * FROM ngx_directories WHERE serviceid='$SERVICE_ID' AND enabled=1 ORDER BY directory");
    $CountOfDirectories=count($results);
    $f[]="";
    $f[]="# Count of Locations: $CountOfDirectories";
    foreach ($results as $index=>$ligneDir){
        $Directory      = $ligneDir["directory"];
        $DirectoryID    = $ligneDir["ID"];
        $deny           = intval($ligneDir["deny"]);
        if($deny==1){$item_prefix="allow";}else{$item_prefix="deny";}

        if(preg_match("#(\(|\)|\|\[|\]|\.\*|\?)#",$Directory)){
            $Directory="~ $Directory";
        }

        $f[]="\tlocation $Directory {";
        $resultsItems=$q->QUERY_SQL("SELECT * FROM ngx_subdir_items WHERE directoryid='$DirectoryID' ORDER BY zorder");
        foreach ($resultsItems as $index=>$ligneItems){
            if($ligneItems["item"]=="*"){$ligneItems["item"]="all";}
            $f[]="\t\t$item_prefix {$ligneItems["item"]};";

        }
        if($deny==1){
            $f[]="\t\tdeny all;";}
        else{
            $f[]="\t\tallow all;";
        }
        $f[]=$proxy_directives;
        $f[]="\t}";
    }
//-------------------------------------------------------------------------------------------------------------------------------------




    $f[]="# ModSecurity Installed = $NginxHTTPModSecurity , ModSecurity enabled = $EnableModSecurity";
    $f[]="\tlocation / {";



    $f[]=$proxy_directives;
    $f[]="\t}";


    $f[]="\taccess_log  /var/log/nginx/access.log awc_log;";
    $f[]="\terror_log   /var/log/nginx/error.log;";
    $f[]="}";

    @file_put_contents($mainpath, @implode("\n", $f));
    return @implode("\n", $f);


}

function cache_directives($SERVICE_ID,$proxy_pass,$stubmodule=null){

    $nginxsock = new socksngix(0);
    $proxy_cache_valid_default=intval($nginxsock->GET_INFO("proxy_cache_valid_default"));
    if($proxy_cache_valid_default==0){$proxy_cache_valid_default=720;}
    $NginxProxyStorePath=$nginxsock->GET_INFO("NginxProxyStorePath");


	if($NginxProxyStorePath==null){$NginxProxyStorePath="/home/nginx";}


    $sockngix = new socksngix($SERVICE_ID);
    $HostHeader=trim($sockngix->GET_INFO("HostHeader"));
    $cache_images = intval($sockngix->GET_INFO("cache_images"));
    $cache_htmlext = intval($sockngix->GET_INFO("cache_htmlext"));
    $cache_binaries = intval($sockngix->GET_INFO("cache_binaries"));
    $cache_erverything = intval($sockngix->GET_INFO("cache_erverything"));
    if ($cache_erverything == 1) {
        return "# This service must cache everything.";
    }
    if (($cache_images == 0) AND ($cache_htmlext == 0) AND ($cache_binaries == 0)) {
        return "# Do not cache images or html extensions";
    }

    if ($cache_images == 1) {

        $ext[] = "jpe?g";
        $ext[] = "gif";
        $ext[] = "png";
        $ext[] = "bmp";
        $ext[] = "tiff";
        $ext[] = "svg";
        $ext[] = "ico";
        $ext[] = "mp[0-9]+";
        $ext[] = "avi";
        $ext[] = "mid";
        $ext[] = "midi";
        $ext[] = "mov";
        $ext[] = "qt";
        $ext[] = "wav";

    }

    if ($cache_htmlext == 1) {
        $ext[] = "ttf";
        $ext[] = "svg";
        $ext[] = "woff";
        $ext[] = "woff2";
        $ext[] = "eot";
        $ext[] = "java";
        $ext[] = "class";
        $ext[] = "jar";
        $ext[] = "css";
        $ext[] = "scss";
        $ext[] = "js";
        $ext[] = "html";
        $ext[] = "htm";
        $ext[] = "shtm";
        $ext[] = "shtml";
    }


    if ($cache_binaries == 1) {
        $ext[] = "pdf";
        $ext[] = "rar";
        $ext[] = "zip";
        $ext[] = "gz";
        $ext[] = "rpm";
        $ext[] = "deb";
        $ext[] = "iso";
        $ext[] = "ova";
        $ext[] = "nrg";
        $ext[] = "exe";
        $ext[] = "xyz";
        $ext[] = "7z";
        $ext[] = "doc";
        $ext[] = "docx";
        $ext[] = "ppt";
        $ext[] = "pptx";
    }

    $f[]="  location ~* ^.+\.(".@implode("|",$ext).")($|\?) {";
    $f[]="#\taccess_log off;";
    $f[]=      $stubmodule;
    $f[]="\tgzip on;";
    $f[]="\tgzip_min_length 10240;";
    $f[]="\tgzip_types text/plain text/css text/xml text/javascript application/x-javascript application/xml;";
    $f[]="\tgzip_disable \"MSIE [1-6]\.\";";
    $f[]="\tproxy_pass $proxy_pass;";
    $f[]="\tproxy_cache bigcache;";
    $f[]="\tproxy_cache_valid any {$proxy_cache_valid_default}m;";
    $f[]="\tadd_header X-Proxy-Cache \$upstream_cache_status;";
    if($HostHeader<>null){$f[]="\tproxy_set_header Host $HostHeader;";}
    if($HostHeader==null){$f[]="\tproxy_set_header Host \$host;";}
    $f[]="\tproxy_set_header Accept-Encoding \"\";";
    $f[]="\tproxy_set_header X-Real-IP \$remote_addr;";
    $f[]="\tproxy_set_header X-Forwarded-For \$remote_addr;";


    $f[]="  }";


    return @implode("\n",$f)."\n";

}

