<?php
include_once(dirname(__FILE__)."/class.squid.externals.acls.childrens.inc");
include_once(dirname(__FILE__)."/class.memcached.inc");
class external_acls_squid{
	
	private $ASROOT=false;
	private $SquidClientParams=array();
	private $SQUID_VERSION=null;
	private $IS_31=false;
	private $IS_32=false;
	private $IS_40=false;
	private $IS_35=false;
	private $SquidUrgency=0;
	private $EnableKerbAuth=0;
	private $LDAP_AUTH=0;
	private $LDAP_EXTERNAL_AUTH=0;
	private $SQUID_VERSIONS_LOGS=array();
	private $CORP_LICENSE=false;
	private $SquidUsersNumber=0;
	private $ActiveDirectoryEmergency=0;
	private $UfdbEnableParanoidMode=0;
	private $MacToUidUrgency=0;
	public $EnforceArticaCategories=false;
	private $LockActiveDirectoryToKerberos=0;
	private $SquidDisableAllFilters=0;
	private $external_acl_childrens;
	private $EnableipV6=0;
	private $memcached;
	
	public function __construct(){
		$sock=new sockets();
		if(!isset($GLOBALS["CLASS_USERS"])){$GLOBALS["CLASS_USERS"]=new usersMenus();}
		$users=$GLOBALS["CLASS_USERS"];
		$this->memcached=new lib_memcached();
		if(posix_getuid()==0){$this->ASROOT=true;}
		$this->SquidClientParams=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidClientParams")));
		$this->SQUID_VERSION=$this->root_squid_version_nocache();
		$this->SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
		$this->EnableKerbAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth"));
		$this->LockActiveDirectoryToKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
		if($this->LockActiveDirectoryToKerberos==1){$this->EnableKerbAuth=1;}
		$this->UfdbEnableParanoidMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbEnableParanoidMode"));
		$this->ActiveDirectoryEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActiveDirectoryEmergency"));
		$this->MacToUidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MacToUidUrgency"));
		$this->DynamicACLUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DynamicACLUrgency"));
		$this->SquidDisableAllFilters=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDisableAllFilters"));
		$ArticaSquidParameters=$GLOBALS["CLASS_SOCKETS"]->GET_INFO('ArticaSquidParameters');
		if(preg_match("#^3\.[0|1]\.#",$this->SQUID_VERSION)){$this->IS_31=true;}
		if(preg_match("#^3\.[2|3|4|5|6|7|8]\.#",$this->SQUID_VERSION)){$this->IS_32=true;}
		if(preg_match("#^3\.[5|6|7|8]\.#",$this->SQUID_VERSION)){$this->IS_35=true;}
		if(preg_match("#^4\.[0|1|2|3|4|5]\.#",$this->SQUID_VERSION)){$this->IS_32=true;$this->IS_40=true;}
		$ini=new Bs_IniHandler();
		$ini->loadString($ArticaSquidParameters);
		$this->LDAP_AUTH=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStandardLDAPAuth"));
		$this->SquidUsersNumber=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUsersNumber"));
		$this->LDAP_EXTERNAL_AUTH=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidExternLDAPAUTH"));
		$this->EnableipV6=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));
		$this->CORP_LICENSE=$users->CORP_LICENSE;
		$this->external_acl_childrens=new external_acl_children_class();
		$this->defaultsvalues();
	}
	
	
	
	public function Build(){
		$conf[]="# Squid version $this->SQUID_VERSION";
		$conf[]="# Saved on ".date("Y-m-d H:i:s")." version 1.0";
		$conf[]="# Auth enabled: ".$this->is_auth();
		if($this->SquidUrgency==1){
			$conf[]="# SquidUrgency == 1";
			@file_put_contents("/etc/squid3/external_acls.conf", @implode("\n", $conf)."\n");
			return;
		}
		if($this->LDAP_AUTH==1){$conf[]="# LDAP_AUTH == 1";}
		if($this->LDAP_EXTERNAL_AUTH==1){$conf[]="# LDAP_EXTERNAL_AUTH == 1";}
		if($this->EnableKerbAuth==1){$conf[]="# EnableKerbAuth == 1";}
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		

		
		$conf[]=$this->external_acl_first();
		$conf[]=$this->external_acl_paranoid();
		$conf[]=$this->external_acl_helper_categories();
		$conf[]=$this->external_acls_helper_size_quota_acl();
		$conf[]=$this->external_acl_helper_restrict_access();
		
		$conf[]=$this->external_acl_helper_time_quota_acl();
		
		$conf[]=$this->external_acl_dynamic_helper();
		$conf[]=$this->external_acl_ext_time_quota();
		$conf[]=$this->external_acl_ext_session();
		//$conf[]=$this->external_acl_filewatcher();
		$conf[]=$this->external_acl_helper_hypercache();
		$conf[]=$this->external_acl_helper_external_active_directory();
		@file_put_contents("/etc/squid3/external_acls.conf", @implode("\n", $conf)."\n");
		
	}
	
	private function external_acl_helper_time_quota_acl(){
		if($this->SquidUrgency==1){return null;}
		if(!$this->ASROOT){return;}
		$acl=new squid_acls_quotas_time();
		return $acl->build()."\n";
	}
	
	private function external_acls_helper_size_quota_acl(){
		$f[]="#\tQUOTA SIZE HELPER -----------------------------";
		if($this->SquidUrgency==1){$f[]="# Emergency enabled";return @implode("\n", $f);}
		if($this->SquidDisableAllFilters==1){$f[]="# All filters are disabled";return @implode("\n", $f);}
		
		
		$EnableQuotaSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableQuotaSize"));
		$SquidQuotaSizeCacheTime=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidQuotaSizeCacheTime"));
		if($SquidQuotaSizeCacheTime==0){$SquidQuotaSizeCacheTime=60;}
		
		
		$ForceConf["ttl"]=$SquidQuotaSizeCacheTime;
		$ForceConf["negative_ttl"]=$SquidQuotaSizeCacheTime;
		$SizeQuotasCheckerEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SizeQuotasCheckerEmergency"));
		if($SizeQuotasCheckerEmergency==1){$f[]="# Emergency enabled - SizeQuotasCheckerEmergency";return @implode("\n", $f);}
		if($EnableQuotaSize==0){$f[]="# EnableQuotaSize id OFF";return @implode("\n", $f);}
		$users=new usersMenus();
		if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){$f[]="# EnableQuotaSize License error";return @implode("\n", $f);}
		$LOGON="%%";
		$SRCEUI48="%SRCEUI48";
		if($this->IS_31){$SRCEUI48=null;}
		if($SRCEUI48==null){$SRCEUI48="%%";}
		if($this->is_auth()){$L[]="%LOGIN";}else{$L[]="%%";}
		$L[]="%SRC";
		$L[]=$SRCEUI48;
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%DST";
		$CMDILES=@implode(" ", $L);
		$external_acl_childrens=$this->external_acl_childrens->build(0,false,$ForceConf);
		if($this->IS_32){$ipv4=" ipv4";}
		$f[]="#";
		$f[]="external_acl_type ArtQuotaSize  $external_acl_childrens concurrency=16 ".@implode(" ", $L)." /usr/share/artica-postfix/squid-size-helper.py\n";
		$f[]="#";
		@chmod("/usr/share/artica-postfix/squid-size-helper.py", 0755);
		@chown("/usr/share/artica-postfix/squid-size-helper.py","squid");
		@chgrp("/usr/share/artica-postfix/squid-size-helper.py","squid");
		return @implode("\n", $f);
		/*acl toto external ArtQuotaSize pipi;pop;cool:1
http_access deny !toto
acl toto2 tag BANDWIDTH:TOTO
http_access deny toto2
*/
	}
	

	


	
	
	private function external_acl_ext_time_quota(){

		if($this->SquidUrgency==1){return null;}
		if(!is_file("/lib/squid3/ext_time_quota_acl")){return null;}
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");

		if(!$q->TABLE_EXISTS("quota_objects")){return null;}
		if($q->COUNT_ROWS("quota_objects")==0){return null;}
		$sql="SELECT *  FROM `quota_objects`";
		$results = $q->QUERY_SQL($sql);
		
		$indentifierZ["LOGIN"]="%un";
		$indentifierZ["SRC"]="%SRC";
		$indentifierZ["SRCEUI48"]="%SRCEUI48";
		$indentifierZ["EXT_TAG"]="%EXT_TAG";
		
		foreach($results as $index=>$ligne) {
			$ttl=$ligne["ttl"];
			$ForceConf["ttl"]=$ttl;
			$ForceConf["children-startup"]=1;
			$ID=$ligne["ID"];
			$external_acl_childrens=$this->external_acl_childrens->build(0,true,$ForceConf);
			$objectname=$ligne["objectname"];
			$sleep=intval($ligne["sleep"]);
			if($sleep==0){$sleep=60;}
			$cmd=array();
			$f[]="# Time Quota id $ID {$objectname}";
			$cmd[]="external_acl_type ExTimeQuota{$ligne["ID"]}";
			$cmd[]="$external_acl_childrens";
			$cmd[]="{$indentifierZ[$ligne["identifier"]]}";
			$cmd[]="/lib/squid3/ext_time_quota_acl";
			$cmd[]="-b /etc/squid3/acls/time_{$ID}.db";
			$cmd[]="-p $sleep";
			$cmd[]="-l /var/log/squid/ext_time_quota_acl.log";
			$cmd[]="/etc/squid3/acls/time_{$ID}.txt";
			$f[]=@implode(" ", $cmd);
			$f[]="";
			if(!is_file("/etc/squid3/acls/time_{$ID}.txt")){@touch("/etc/squid3/acls/time_{$ID}.txt");}
			
		}
		
		return @implode("\n", $f)."\n";
		
	}
	private function external_acl_ext_session(){
		$sock=new sockets();
		if($this->SquidUrgency==1){return null;}
		if(!is_file("/lib/squid3/ext_session_acl")){return null;}
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");

		if(!$q->TABLE_EXISTS("sessions_objects")){
            $sql="CREATE TABLE IF NOT EXISTS `sessions_objects` (
	            `ID` INTEGER PRIMARY KEY AUTOINCREMENT,`objectname` TEXT,
	            `ttl` INTEGER,`sleep` INTEGER,`identifier` TEXT NOT NULL DEFAULT 'SRC') ";
            $q->QUERY_SQL($sql);
        }

	
		if($q->COUNT_ROWS("sessions_objects")==0){return ;}
		$sql="SELECT *  FROM `sessions_objects`";
		$results = $q->QUERY_SQL($sql);
	
		$indentifierZ["LOGIN"]="%un";
		$indentifierZ["SRC"]="%SRC";
		$indentifierZ["SRCEUI48"]="%SRCEUI48";
		$indentifierZ["EXT_TAG"]="%EXT_TAG";
	
		foreach($results as $index=>$ligne) {
			$ttl=$ligne["ttl"];
			$ForceConf["ttl"]=3;
			$ForceConf["children-startup"]=1;
			$ID=$ligne["ID"];
			$external_acl_childrens=$this->external_acl_childrens->build(0,true,$ForceConf);
			$objectname=$ligne["objectname"];
			$sleep=intval($ligne["sleep"]);
			if($sleep==0){$sleep=60;}
			$cmd=array();
			$f[]="# Time Quota id $ID {$objectname}";
			$cmd[]="external_acl_type SessionTrack{$ligne["ID"]}";
			$cmd[]="concurrency=100 $external_acl_childrens";
			$cmd[]="{$indentifierZ[$ligne["identifier"]]}";
			$cmd[]="/lib/squid3/ext_session_acl";
			$cmd[]="-a -T $ttl -b /etc/squid3/acls/sessions_{$ID}";
			@mkdir("/etc/squid3/acls/sessions_{$ID}",0755,true);
			@chown("/etc/squid3/acls/sessions_{$ID}","squid");
			@chgrp("/etc/squid3/acls/sessions_{$ID}", "squid");
			$f[]=@implode(" ", $cmd);
			//$f[]="acl SessionTrack{$ligne["ID"]}_LOGIN external SessionTrack{$ligne["ID"]} LOGIN";
			//$f[]="acl SessionTrack{$ligne["ID"]}_ACTIVE external SessionTrack{$ligne["ID"]}";
			//$f[]="acl SessionTrack{$ligne["ID"]}_LOGOUT external SessionTrack{$ligne["ID"]} LOGOUT";
			
				
		}
	
		return @implode("\n", $f)."\n";
	
	}	
	
	private function external_acl_dynamic_helper(){
	
		$f[]="#\tExternal ACLs Dynamics -----------------------------";
		if($this->DynamicACLUrgency==1){$f[]="# !!!!!!!!!!!!!!!!! EMERGENCY MODE !!!!!!!!!!!!!!!!!";return @implode("\n", $f)."\n";}
		if($this->SquidUrgency==1){$f[]="# !!!!!!!!!!!!!!!!! EMERGENCY MODE !!!!!!!!!!!!!!!!!";return @implode("\n", $f)."\n";}
		if(!$this->CORP_LICENSE){$f[]="# No License to use this plugin";return @implode("\n", $f)."\n";}
		
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$logprepend="[ACLS]";
		if($GLOBALS["VERBOSE"]){$logprepend="[DYNAACLS]";}
		$sock=new sockets();
		$sql="SELECT COUNT( * ) AS TCOUNT FROM (
				SELECT webfilters_sqaclaccess.aclid, webfilters_sqacllinks.gpid, webfilters_sqgroups.ID
				FROM webfilters_sqaclaccess, webfilters_sqacllinks, webfilters_sqgroups
				WHERE webfilters_sqaclaccess.aclid = webfilters_sqacllinks.aclid
				AND webfilters_sqacllinks.gpid = webfilters_sqgroups.ID
				AND webfilters_sqgroups.GroupType = 'dynamic_acls'
				AND webfilters_sqgroups.enabled = 1
		) AS t";
	
		$ligne=$q->mysqli_fetch_array($sql);
	
		if(!$q->ok){
			$f[]="# Mysql Error ".__FUNCTION__." in line ".__LINE__;
			if($this->ASROOT){echo "Starting......: ".date("H:i:s")." $logprepend: MySQL Error: $q->mysql_error\n";}
		}
	
		if($ligne["TCOUNT"]==0){
			$f[]="# Rules number = 0 ".__FUNCTION__." in line ".__LINE__;
			if($this->ASROOT){echo "Starting......: ".date("H:i:s")." $logprepend: Dynamic ACLS ({$ligne["TCOUNT"]} item)\n";}
			return @implode("\n", $f);
		}
		$ACLS_OPTIONS=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AclsOptions")));
	
	
	
		if(!isset($ACLS_OPTIONS["DYN_TTL"])){$ACLS_OPTIONS["DYN_TTL"]=120;}
		if(!is_numeric($ACLS_OPTIONS["DYN_TTL"])){$ACLS_OPTIONS["DYN_TTL"]=120;}
	
	
		if($this->ASROOT){echo "Starting......: ".date("H:i:s")." $logprepend: Dynamic ACLS ({$ligne["TCOUNT"]} item(s))\n";}
	
		
		$L[]="%un";
		$L[]="%SRC";
		$L[]="%SRCEUI48";
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%DST";
		
	
	
		$ForceConf["ttl"]=$ACLS_OPTIONS["DYN_TTL"];
		$ForceConf["negative_ttl"]=$ACLS_OPTIONS["DYN_TTL"];
		if(isset($ACLS_OPTIONS["CHILDREN_STARTUP"])){$ForceConf["children-startup"]=$ACLS_OPTIONS["CHILDREN_STARTUP"];}
		if(isset($ACLS_OPTIONS["CHILDREN_IDLE"])){$ForceConf["children-idle"]=$ACLS_OPTIONS["CHILDREN_IDLE"];}
		
	
		$external_acl_childrens=$this->external_acl_childrens->build(0,true,$ForceConf);
		$f[]="external_acl_type DynamicAcls concurrency=16 $external_acl_childrens ".@implode(" ", $L)."  /usr/bin/python /usr/share/artica-postfix/external_acl-dynamics.py";
		return @implode("\n", $f)."\n";
	}

	private function external_acl_helper_external_active_directory(){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$logprepend="[ACLS]";
		if($GLOBALS["VERBOSE"]){$logprepend="[DYNAACLS]";}
		$sock=new sockets();
		$sql="SELECT COUNT( * ) AS TCOUNT FROM (
				SELECT webfilters_sqaclaccess.aclid, webfilters_sqacllinks.gpid, webfilters_sqgroups.ID
				FROM webfilters_sqaclaccess, webfilters_sqacllinks, webfilters_sqgroups
				WHERE webfilters_sqaclaccess.aclid = webfilters_sqacllinks.aclid
				AND webfilters_sqacllinks.gpid = webfilters_sqgroups.ID
				AND webfilters_sqgroups.GroupType = 'proxy_auth_extad'
				AND webfilters_sqgroups.enabled = 1
		) AS t";
		
		$ligne=$q->mysqli_fetch_array($sql);
		
		if(!$q->ok){
			$f[]="# Mysql Error ".__FUNCTION__." in line ".__LINE__;
		}
		
		if($ligne["TCOUNT"]==0){
			$f[]="# Rules number = 0 ".__FUNCTION__." in line ".__LINE__;
			return @implode("\n", $f);
		}
		
		$f[]="#\tEXTERNAL ACTIVE DIRECTORY HELPER -----------------------------";
		$ForceConf["concurrency"]=10;
		$external_acl_childrens=$this->external_acl_childrens->build(0,false,$ForceConf);
		$L[]=$this->LOGIN();
		$helper="/usr/bin/python /usr/share/artica-postfix/external_acl_extad.py";
		@chmod("/usr/share/artica-postfix/external_acl_extad.py",0755);
		@chown("/usr/share/artica-postfix/external_acl_extad.py","squid");
		$f[]="external_acl_type ExternalAdGroup {$external_acl_childrens} ".@implode(" ", $L)." $helper";
		return @implode("\n", $f);
	}
	
	
	private function LOGIN(){
		$LOGIN="%LOGIN";
		if(!$this->is_auth()){$LOGIN="%un";}
		if($LOGIN==null){$LOGIN="%%";}
		return $LOGIN;
	}
	
	private function SRCEUI48(){
		$SRCEUI48="%SRCEUI48";
		if($this->IS_31){$SRCEUI48=null;}
		if($SRCEUI48==null){$SRCEUI48="%%";}
		return $SRCEUI48;
	}
	
	private function external_acl_paranoid(){
		if($this->SquidUrgency==1){return null;}
		if($this->UfdbEnableParanoidMode==0){return "\n# Paranoid mode disabled\n"; }
		$sock=new sockets();
		if($sock->EnableUfdbGuard()==0){return "\n# Web filtering disabled\n"; }
		$ParanoidBlockerEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ParanoidBlockerEmergency"));
		if($ParanoidBlockerEmergency==1){return "\n# Paranoid Emergency\n"; }
		
		$ipv4=null;
	
		$ForceConf["concurrency"]=10;
		$external_acl_childrens=$this->external_acl_childrens->build(0,false,$ForceConf);
		$SRCEUI48=$this->SRCEUI48();
		
		$L[]="%EXT_USER";
		$L[]="%SRC";
		$L[]=$SRCEUI48;
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%DST";
		

		$helper="/usr/share/artica-postfix/external_acl_paranoid.php";
		$f[]="external_acl_type ParanoidBlocker {$external_acl_childrens} ".@implode(" ", $L)." $helper";
		$f[]="acl IsBlockParanoid external ParanoidBlocker";
		$f[]="acl IsMgRPort myportname MyManagerPort";
		$f[]="http_access deny !IsMgRPort IsBlockParanoid all";
		$f[]="deny_info ERR_PARANOID IsBlockParanoid";
		@chmod($helper,0755);
		return @implode("\n", $f);
	
	
	}

	
	private function external_acl_filewatcher(){
		if($this->SquidUrgency==1){return null;}
		$ipv4=null;
		
		$ForceConf["ttl"]=0;
		$ForceConf["negative_ttl"]=0;
		
		$external_acl_childrens=$this->external_acl_childrens->build(0,false,$ForceConf);
		$SRCEUI48=$this->SRCEUI48();
		$LOGIN=$this->LOGIN();
		$L[]=$LOGIN;
		$L[]="%EXT_USER";
		$L[]="%SRC";
		$L[]=$SRCEUI48;
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%URI";
		$L[]="%<h{Content-Type} %<h{Content-Disposition} %<h{Content-Length}";
		if($this->IS_32){$ipv4=" ipv4";}
		


		$helper="/usr/share/artica-postfix/external_acl_response.php";
		$f[]="external_acl_type FileWatcherExt {$external_acl_childrens}{$ipv4} ".@implode(" ", $L)." $helper";
		$f[]="acl FileWatcher external FileWatcherExt";
		
		@chmod($helper,0755);
		
		return @implode("\n", $f);
		
		
	}

	
	
	
	//external_acl_helper_MacToUid

	//external_acl_first
	
	public function external_acl_first(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){
			@file_put_contents("/etc/squid3/external_categorize.conf", "\n");
			return;
		}
		if(!$this->ASROOT){return;}
		$unix=new unix();
		$php=$unix->LOCATE_PHP5_BIN();
		system("$php /usr/share/artica-postfix/exec.usrmactranslation.php --no-reload");
		$array["CACHE_TIME"]=360;
		
		$helper="/usr/share/artica-postfix/external_acl_first.php";
		@chmod("/usr/share/artica-postfix/external_acl_first.php",0755);
		@chown("/usr/share/artica-postfix/external_acl_first.php","squid");
		if(!is_dir("/home/squid/licenses")){@mkdir("/home/squid/licenses",0777,true);}
		@chown("/home/squid/licenses","squid");
		@chgrp("/home/squid/licenses", "squid");


		$L[]="%un";
		$L[]="%SRC";
		$L[]="%SRCEUI48";
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%DST";
		$L[]="%ssl::>sni";
		$L[]="%USER_CERT_CN";
		
		$ForceConf["ttl"]=3600;
		
		$Childs[]="ttl=3600";
		$Childs[]="negative_ttl=3600";
		$Childs[]="children-startup=10";
		$Childs[]="children-idle=2";
		$Childs[]="children-max=50";
		$Childs[]="concurrency=1";
		$Childs[]="ipv4";
		
		$f[]="external_acl_type MacToUid  ".@implode(" ", $Childs)." ".@implode(" ", $L)." $helper";
		$f[]="acl MacToUid_acl external MacToUid\n";
		$f[]="http_access deny !MacToUid_acl";
		@file_put_contents("/etc/squid3/external_categorize.conf", @implode("\n", $f));
	
	}	
	
	

	private function NoAuthPorts(){

        $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));
        $HaClusterClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));

        if($HaClusterClient==1){
            if($HaClusterTransParentMode==1){
                return "!NoAuthPort ";
            }
        }

		$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$sql="SELECT COUNT(*) as TCOUNT FROM proxy_ports WHERE enabled=1 and NoAuth=1";
		$ligne=$q->mysqli_fetch_array($sql);
		if(intval($ligne["TCOUNT"])==0){return null;}
		return "!NoAuthPort ";
	}
	
	private function external_acl_helper_restrict_access(){
		if($this->SquidUrgency==1){return null;}
		if(!$this->ASROOT){return;}
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");

		if(!$q->TABLE_EXISTS("computers_time")){
            $q->QUERY_SQL("CREATE TABLE IF NOT EXISTS `computers_time` (
				`MAC` TEXT PRIMARY KEY NOT NULL,
				`ipaddr` TEXT NOT NULL,
				`enabled` INTEGER NOT NULL DEFAULT 0,
				`MONDAY_AM` TEXT NOT NULL,
				`MONDAY_PM` TEXT NOT NULL,
				`TUESDAY_AM` TEXT NOT NULL,
				`TUESDAY_PM` TEXT NOT NULL,
				`WEDNESDAY_AM` TEXT NOT NULL,
				`WEDNESDAY_PM` TEXT NOT NULL,
				`THURSDAY_AM` TEXT NOT NULL,
				`THURSDAY_PM` TEXT NOT NULL,
				`FRIDAY_AM` TEXT NOT NULL,
				`FRIDAY_PM` TEXT NOT NULL,
				`SATURDAY_AM` TEXT NOT NULL,
				`SATURDAY_PM` TEXT NOT NULL,
				`SUNDAY_AM` TEXT NOT NULL,
				`SUNDAY_PM` TEXT NOT NULL)");
		    return false;
		}


		$sql="SELECT * FROM computers_time WHERE `enabled`=1";
		$array["CACHE_TIME"]=300;
		$results = $q->QUERY_SQL($sql);
		$helper="/usr/share/artica-postfix/external_acl_restrict_access.php";
		@chmod($helper,0755);
		$ligne=$q->mysqli_fetch_array("SELECT COUNT(*) as tcount FROM computers_time WHERE `enabled`=1");
		if(!is_numeric($ligne["tcount"])){$ligne["tcount"]=0;}
		if($ligne["tcount"]==0){return false;}
		$L[]="%SRC";
		$L[]="%SRCEUI48";
		$L[]="%>ha{X-Forwarded-For}";
		if($this->IS_32){$ipv4=" ipv4";}
		$external_acl_childrens=$this->external_acl_childrens->build();
		$f[]="external_acl_type ArticaRestrictAccess  $external_acl_childrens ".@implode(" ", $L)." $helper";
		$f[]="acl ArticaRestrictAccess external ArticaRestrictAccess\n";
		$GLOBALS["HTTP_ACCESS"]["ArticaRestrictAccess"]="http_access deny ArticaRestrictAccess";
		$UfdbGuardSquidGuardIPWeb=$this->UfdbGuardSquidGuardIPWeb();
		$f[]="# Web filtering error page: \"$UfdbGuardSquidGuardIPWeb\"";
		if($UfdbGuardSquidGuardIPWeb<>null){
			$f[]="deny_info 307:$UfdbGuardSquidGuardIPWeb?clientaddr=%i&clientname=&clientuser=%i&clientgroup=default&targetgroup=restricted_time&url=%u ArticaRestrictAccess";
				
		}
	
	
	
		if(class_exists("unix")){
			if(!class_exists("unix")){include_once("/usr/share/artica-postfix/framework/class.unix.inc");}$unix=new unix();
			$php=$unix->LOCATE_PHP5_BIN();
			$nohup=$unix->find_program("nohup");
			echo "Starting......: ".date("H:i:s")." [MAC]: Restrict Access, building database...\n";
			if($GLOBALS["VERBOSE"]){
				system("$php /usr/share/artica-postfix/exec.squid.computer.access.php --nocheck");
			}else{
				shell_exec("$nohup $php /usr/share/artica-postfix/exec.squid.computer.access.php --nocheck >/dev/null 2>&1 &");
			}
		}
	
		return @implode("\n", $f)."\n";
	}	


	
	public function external_acl_helper_hypercache(){
		
		$HyperCacheEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HyperCacheEmergency"));
		if($HyperCacheEmergency==1){return "# external_acl_helper_hypercache HyperCache Emergency !...\n";}
		
		$EnableHyperCacheProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableHyperCacheProxy"));
		if($EnableHyperCacheProxy==0){return "# external_acl_helper_hypercache HyperCache not set...\n";}
		$ScriptFileName="/usr/share/artica-postfix/external_acl_hypercache.py";
		if($this->SquidUrgency==1){return "# external_acl_helper_hypercache:: SquidUrgency is enabled, aborting\n";}
		$L[]="%URI";
		$CMDILES=@implode(" ", $L);
		$ForceConf["concurrency"]=16;
		$external_acl_childrens=$this->external_acl_childrens->build(0,false,array());
		$f[]="external_acl_type HyperCacheExtrn concurrency=1 $external_acl_childrens $CMDILES $ScriptFileName\n";
		$f[]="acl HyperCachePlugin external HyperCacheExtrn";
		$f[]="http_access deny !HyperCachePlugin";
		$f[]="acl HyperCacheTagged note hypercache 1";
		@chmod($ScriptFileName, 0755);
		@chown($ScriptFileName, "squid");
		return @implode("\n", $f);
		
	}
	
	public function external_acl_helper_categories(){
		$ScriptFileName="/usr/share/artica-postfix/external_acl_categories.php";
		$GLOBALS["ArtcExtrnCategoryScanner"]=false;
		$sock=new sockets();
		if(!$this->CORP_LICENSE){return "# No license set\n";}
		$SquidPerformance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidPerformance"));
		$RemoteUfdbCat=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RemoteUfdbCat"));
		$EnableLocalUfdbCatService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableLocalUfdbCatService"));
        $UseCloudArticaCategories=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseCloudArticaCategories"));
		$CATEGORY_UNSET=false;
		if($SquidPerformance>0){$CATEGORY_UNSET=true;}
		if($EnableLocalUfdbCatService==1){$CATEGORY_UNSET=false;}
		if($RemoteUfdbCat==1){$CATEGORY_UNSET=false;}
		if($UseCloudArticaCategories==1){$CATEGORY_UNSET=false;}
		
		
		if($CATEGORY_UNSET){
			
				return "# external_acl_helper_categories:: No enabled for performance reason\n";;
			
		}
		if($this->SquidUrgency==1){return "# external_acl_helper_categories:: SquidUrgency is enabled, aborting\n";}
		if(!$this->ASROOT){return;}
		$array["CACHE_TIME"]=360;
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		if(!$this->EnforceArticaCategories){
			$sql="SELECT COUNT( * ) as tcount
				FROM webfilters_sqgroups, webfilters_sqacls, webfilters_sqacllinks
				WHERE webfilters_sqacllinks.aclid = webfilters_sqacls.ID
				AND webfilters_sqacllinks.gpid = webfilters_sqgroups.ID
				AND webfilters_sqgroups.GroupType = 'categories'
				AND webfilters_sqgroups.enabled =1
				AND webfilters_sqacls.enabled =1";
			$ligne=$q->mysqli_fetch_array($sql);
			if(!$q->ok){if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [CATZ]: Categories $q->mysql_error\n";}return;}
			if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [CATZ]: Categories {$ligne["tcount"]} items\n";}
			if($ligne["tcount"]==0){
				return "# external_acl_helper_categories:: first query return no item\n";
			}
		}
		
		if($this->EnforceArticaCategories){
			$f[]="# EnforceArticaCategories == True";
		}
	
		$LOGON="%%";
		$SRCEUI48="%SRCEUI48";
		
		if($this->IS_31){$SRCEUI48=null;}
		if($SRCEUI48==null){$SRCEUI48="%%";}
		$L[]="%EXT_LOG";
		$L[]="%ACL";
		$L[]="%%";
		$L[]="%SRC";
		$L[]=$SRCEUI48;
		$L[]="%>ha{X-Forwarded-For}";
		$L[]="%DST";
		$CMDILES=@implode(" ", $L);
	
		
		$CategoriesHelperConcurrency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperConcurrency"));
		$CategoriesHelperChildrenMax=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperChildrenMax"));
		$CategoriesHelperHidden=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperHidden"));
		$CategoriesHelperStartup=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperStartup"));
		$CategoriesHelperPostitiveTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperPostitiveTTL"));
		$CategoriesHelperNegativeTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesHelperNetgativeTTL"));
		
		
		if($CategoriesHelperNegativeTTL==0){$CategoriesHelperNegativeTTL=360;}
		if($CategoriesHelperPostitiveTTL==0){$CategoriesHelperPostitiveTTL=360;}
		if($CategoriesHelperChildrenMax==0){$CategoriesHelperChildrenMax=5;}
		if($CategoriesHelperStartup==0){$CategoriesHelperStartup=2;}
		if($CategoriesHelperHidden==0){$CategoriesHelperHidden=1;}
		
		
		$ForceConf["ttl"]=$CategoriesHelperPostitiveTTL;
		$ForceConf["negative_ttl"]=$CategoriesHelperNegativeTTL;
		$ForceConf["children-startup"]=$CategoriesHelperStartup;
		$ForceConf["children-idle"]=$CategoriesHelperHidden;
		$ForceConf["concurrency"]=$CategoriesHelperConcurrency;
		
		$external_acl_childrens=$this->external_acl_childrens->build($CategoriesHelperChildrenMax,false,$ForceConf);
		
		
		
		$sql="SELECT webfilters_sqgroups.*,webfilters_sqacls.aclname
			FROM webfilters_sqgroups, webfilters_sqacls, webfilters_sqacllinks
			WHERE webfilters_sqacllinks.aclid = webfilters_sqacls.ID
			AND webfilters_sqacllinks.gpid = webfilters_sqgroups.ID
			AND webfilters_sqgroups.GroupType = 'categories'
			AND webfilters_sqgroups.enabled =1
			AND webfilters_sqacls.enabled =1";
		$results=$q->QUERY_SQL($sql);

		if(!$q->ok){
		    echo "############################################################\n$q->mysql_error\n############################################################\n";
        }
		
		if(count($results)==0){
            if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [CATZ]: No group use category item\n";}
			return "# external_acl_helper_categories:: Rows number == 0 \n";
			
		}
		$GLOBALS["ArtcExtrnCategoryScanner"]=true;
	
		foreach($results as $index=>$ligne) {
			$GLOBALS["LoadingArtcatz"][$ligne["ID"]]=true;
            if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [CATZ]: Search categories for group {$ligne["ID"]}\n";}
			$this->external_acl_helper_categories_items($ligne["ID"]);
			
		}
		
		$f[]="external_acl_type ArtCategories $external_acl_childrens $CMDILES $ScriptFileName\n";
	
		@chmod($ScriptFileName, 0755);
		@chown($ScriptFileName, "squid");
		return @implode("\n", $f);
	
	}
	
	private function external_acl_helper_categories_items($gpid){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
        $sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
		$results = $q->QUERY_SQL($sql);
		foreach($results as $index=>$ligne) {
			$HASH[$ligne["pattern"]]="{$ligne["pattern"]}";
		}

        if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [CATZ]: {$gpid} = ".count($HASH)." categories\n";}
		@file_put_contents("/etc/squid3/acls/catz_gpid{$gpid}.acl", serialize($HASH));
	}
	
	private function external_acl_childrens($MacProc=0,$NoNegCache=false,$ForceConf=array()){
	
		$array["CACHE_TIME"]=360;
		$external_acl_children=intval($this->external_acl_children());
		$MacProc=$external_acl_children;
		$external_acl_startup=$this->SquidClientParams["external_acl_startup"];
		$external_acl_idle=$this->SquidClientParams["external_acl_idle"];
		$external_acl_concurrency=0;
		$negative_ttl=$array["CACHE_TIME"];
		$ttl=$array["CACHE_TIME"];
	
	
	
		if(isset($ForceConf["ttl"])){$ttl=$ForceConf["ttl"];}
		if(isset($ForceConf["negative_ttl"])){$negative_ttl=$ForceConf["ttl"];}
		if(isset($ForceConf["children-startup"])){$external_acl_startup=$ForceConf["children-startup"];}
		if(isset($ForceConf["children-idle"])){$external_acl_idle=$ForceConf["children-idle"];}
		if(isset($ForceConf["concurrency"])){$external_acl_concurrency=$ForceConf["concurrency"];}
		if($external_acl_startup==0){$external_acl_startup=5;}
		if($external_acl_idle<1){$external_acl_idle=1;}
		if($MacProc<$external_acl_startup){$MacProc=$external_acl_startup;}
		if($MacProc<5){$MacProc=5;}
	
		$f[]="ttl=$ttl";
		if(!$NoNegCache){
			$f[]="negative_ttl=$negative_ttl";
		}else{
			$f[]="negative_ttl=0";
		}
		if($this->IS_32){
			$f[]="children-startup={$external_acl_startup}";
			$f[]="children-idle={$external_acl_idle}";
			$f[]="children-max=$MacProc";
			if($external_acl_concurrency>0){
				$f[]="concurrency=$external_acl_concurrency";
			}
			if($this->EnableipV6==0){$f[]="ipv4";}
		}else{
				
			if($external_acl_startup>1){
				$f[]="children=$MacProc";
			}
		}
	
		return @implode(" ", $f);
	
	}
	

	private function UfdbGuardSquidGuardIPWeb(){
		if(isset($GLOBALS["SquidGuardIPWebMEM"])){return $GLOBALS["SquidGuardIPWebMEM"];}
		$sock=new sockets();
		if($sock->EnableUfdbGuard()==0){
			$GLOBALS["SquidGuardIPWebMEM"]=null;
			return null;
		}
		include_once(dirname(__FILE__)."/class.compile.ufdbguard.inc");
		$conf=new compile_ufdbguard();
		$SquidGuardIPWeb=unserialize(@file_get_contents("/var/log/squid/SquidGuardIPWeb"));
		if(is_array($SquidGuardIPWeb)){
			$GLOBALS["SquidGuardIPWebMEM"]=$SquidGuardIPWeb["SquidGuardIPWeb"];
		}
	
		return $GLOBALS["SquidGuardIPWebMEM"];
	
	}
	
	private function root_squid_version_nocache(){
		if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
		if(!class_exists("unix")){include_once("/usr/share/artica-postfix/framework/class.unix.inc");}
		$unix=new unix();
	
		$squidbin=$unix->LOCATE_SQUID_BIN();
		if($squidbin==null){$squidbin=trim($unix->find_program("squid3"));}
		if(!is_file($squidbin)){return;}
		exec("$squidbin -v 2>&1",$results);
	
		$this->SQUID_VERSIONS_LOGS[]="# Binary $squidbin";
	
	
		foreach ($results as $num=>$val){
			if(preg_match("#Squid Cache: Version.*?([0-9\.]+)#", $val,$re)){
				$this->SQUID_VERSIONS_LOGS[]="# Version {$re[1]}";
				if($re[1]=="2.7."){$re[1]="2.7.0";}
				if($re[1]=="3.0."){$re[1]="3.0.0";}
				if($re[1]=="3.1."){$re[1]="3.1.0";}
				if($re[1]=="3.2."){$re[1]="3.2.0";}
				if($re[1]=="3.3."){$re[1]="3.3.0";}
				if($re[1]=="3.4."){$re[1]="3.4.0";}
				if($re[1]=="3.5."){$re[1]="3.5.0";}
	
				if(!isset($GLOBALS["NOSQUIDOUTPUT"])){
					echo "Starting......: ".date("H:i:s")." Squid : Version (as root) '{$re[1]}'\n";
				}
				$GLOBALS[__FUNCTION__]=$re[1];
				return $re[1];
			}
		}
	
	}
	
	public function is_auth(){
		if($this->SquidUrgency==1){
		    $this->ERROR[]="# is_auth SquidUrgency =1";
		    return false;
		}
		if(isset($GLOBALS["squid_is_auth2"])){return $GLOBALS["squid_is_auth2"];}
			
		$GLOBALS["squid_is_auth2"]=$this->_is_auth();
		return $GLOBALS["squid_is_auth2"];
	}
	
	
	private function _is_auth(){
		if($this->SquidUrgency==1){
            $this->ERROR[]="# _is_auth SquidUrgency =1";
		    return false;}
		if($this->LDAP_AUTH==1){return true;}
		if($this->LDAP_EXTERNAL_AUTH==1){return true;}
		if($this->EnableKerbAuth==1){
			if($this->ActiveDirectoryEmergency==1){
                $this->ERROR[]="# _is_auth ActiveDirectoryEmergency =1";
			    return false;
			}
			return true;
		}
		$sock=new sockets();
		$EnableArticaHotSpot=$sock->GET_INFO("EnableArticaHotSpot");
		if(!is_numeric($EnableArticaHotSpot)){$EnableArticaHotSpot=0;}
		if($EnableArticaHotSpot==1){return true;}
		$acl=new squid_acls();
		if($acl->IsObjectAuth()){return true;}
		return false;
	}	
	
	private function external_acl_children(){
		if(isset($GLOBALS["external_acl_children"])){return $GLOBALS["external_acl_children"];}
		$external_acl_children=$this->SquidClientParams["external_acl_children"];
		if($this->SquidUsersNumber==0){
			$GLOBALS["external_acl_children"]=$external_acl_children;
			return $GLOBALS["external_acl_children"];
		}
	
		
		if($this->SquidUsersNumber>49){$multiplicator=8;}
		if($this->SquidUsersNumber>499){$multiplicator=15;}
		if($this->SquidUsersNumber>1000){$multiplicator=20;}
		if($this->SquidUsersNumber>1500){$multiplicator=30;}

		$GLOBALS["external_acl_children"]=$multiplicator;
		return $multiplicator;
	
	
		$external_acl_startup=$this->SquidClientParams["external_acl_startup"];
		$external_acl_idle=$this->SquidClientParams["external_acl_idle"];
	
	
	
	}
	
	private function defaultsvalues(){
		if(!isset($this->SquidClientParams["auth_param_ntlm_children"])){$this->SquidClientParams["auth_param_ntlm_children"]=20;}
		if(!isset($this->SquidClientParams["auth_param_ntlm_startup"])){$this->SquidClientParams["auth_param_ntlm_startup"]=1;}
		if(!isset($this->SquidClientParams["auth_param_ntlm_idle"])){$this->SquidClientParams["auth_param_ntlm_idle"]=1;}
		
		if(!isset($this->SquidClientParams["auth_param_basic_children"])){$this->SquidClientParams["auth_param_basic_children"]=3;}
		if(!isset($this->SquidClientParams["auth_param_basic_startup"])){$this->SquidClientParams["auth_param_basic_startup"]=1;}
		if(!isset($this->SquidClientParams["auth_param_basic_idle"])){$this->SquidClientParams["auth_param_basic_idle"]=1;}
		
		if(!isset($this->SquidClientParams["url_rewrite_children"])){$this->SquidClientParams["url_rewrite_children"]=10;}
		if(!isset($this->SquidClientParams["url_rewrite_startup"])){$this->SquidClientParams["url_rewrite_startup"]=1;}
		if(!isset($this->SquidClientParams["url_rewrite_idle"])){$this->SquidClientParams["url_rewrite_idle"]=1;}
		
		if(!isset($this->SquidClientParams["external_acl_children"])){$this->SquidClientParams["external_acl_children"]=5;}
		if(!isset($this->SquidClientParams["external_acl_startup"])){$this->SquidClientParams["external_acl_startup"]=1;}
		if(!isset($this->SquidClientParams["external_acl_idle"])){$this->SquidClientParams["external_acl_idle"]=1;}
		
		if(!is_numeric($this->SquidClientParams["auth_param_ntlm_children"])){$this->SquidClientParams["auth_param_ntlm_children"]=20;}
		if(!is_numeric($this->SquidClientParams["auth_param_ntlm_startup"])){$this->SquidClientParams["auth_param_ntlm_startup"]=1;}
		if(!is_numeric($this->SquidClientParams["auth_param_ntlm_idle"])){$this->SquidClientParams["auth_param_ntlm_idle"]=1;}
		
		if(!is_numeric($this->SquidClientParams["auth_param_basic_children"])){$this->SquidClientParams["auth_param_basic_children"]=3;}
		if(!is_numeric($this->SquidClientParams["auth_param_basic_startup"])){$this->SquidClientParams["auth_param_basic_startup"]=2;}
		if(!is_numeric($this->SquidClientParams["auth_param_basic_idle"])){$this->SquidClientParams["auth_param_basic_idle"]=1;}
		
		if(!is_numeric($this->SquidClientParams["url_rewrite_children"])){$this->SquidClientParams["url_rewrite_children"]=10;}
		if(!is_numeric($this->SquidClientParams["url_rewrite_startup"])){$this->SquidClientParams["url_rewrite_startup"]=1;}
		if(!is_numeric($this->SquidClientParams["url_rewrite_idle"])){$this->SquidClientParams["url_rewrite_idle"]=1;}
		
		if(!is_numeric($this->SquidClientParams["external_acl_children"])){$this->SquidClientParams["external_acl_children"]=5;}
		if(!is_numeric($this->SquidClientParams["external_acl_startup"])){$this->SquidClientParams["external_acl_startup"]=1;}
		if(!is_numeric($this->SquidClientParams["external_acl_idle"])){$this->SquidClientParams["external_acl_idle"]=1;}
		if($this->SquidClientParams["external_acl_startup"]<1){$this->SquidClientParams["external_acl_startup"]=2;}
		
		if($this->ActiveDirectoryEmergency==1){$this->EnableKerbAuth=0;}
	}
	
	
}