<?php
if(!isset($GLOBALS["BASE_ROOT"])){$GLOBALS["BASE_ROOT"]="/usr/share/artica-postfix";}
include_once(dirname(__FILE__)."/class.squid.watchdog.inc");





function cicap_watchdog_pid(){
	$unix=new unix();
    $pid=0;
	if(is_file("/etc/artica-postfix/exec.c-icap-watchdog.php.pid")){
		$pid=@file_get_contents("/etc/artica-postfix/exec.c-icap-watchdog.php.pid");
	}
	if($unix->process_exists($pid)){return $pid;}
	$pid=$unix->PIDOF("/bin/c-icap-server-tail");
	if($unix->process_exists($pid)){return $pid;}
	$pid=$unix->PIDOF_PATTERN("exec.c-icap-watchdog.php");
	return $pid;

}
function cicap_access_pid(){
	$unix=new unix();
	$pid=0;
	if(is_file("/etc/artica-postfix/exec.c-icap-access.php.pid")){
		$pid=@file_get_contents("'/etc/artica-postfix/exec.c-icap-access.php.pid'");
	}
	if($unix->process_exists($pid)){return $pid;}
	$pid=$unix->PIDOF("/bin/c-icap-access-tail");
	if($unix->process_exists($pid)){return $pid;}
	$pid=$unix->PIDOF_PATTERN("exec.c-icap-access.php");
    return $pid;
}

function c_icap_access(){
	if(!is_file("etc/init.d/c-icap-access")){return;}

	$master_pid=cicap_access_pid();



	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			squid_admin_mysql(0, "C-ICAP Acccess not running [action=start]", null,__FILE__,__LINE__);
			shell_exec2("$nohup /etc/init.d/c-icap-access start >/dev/null 2>&1 &");
		}
		return;

	}
}

function c_icap_watchdog(){
	if(!is_file("/etc/init.d/c-icap-watchdog")){return;}
	
	$master_pid=cicap_watchdog_pid();
	$php=$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN();
		
		
	
	
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			squid_admin_mysql(0, "C-ICAP watchdog not running [action=start]", null,__FILE__,__LINE__);
			shell_exec2("$nohup /etc/init.d/c-icap-watchdog start >/dev/null 2>&1 &");
		}
		return;
	
	}
}

function c_icap_master_status(){
	$statx="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix";
	$cicapbin=$GLOBALS["CLASS_UNIX"]->find_program("c-icap");

	if(!is_file($cicapbin)){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_INSTALLED", 0);return null;}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_INSTALLED", 1);
	if(is_file("/usr/lib/c_icap/dnsbl_tables.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_DNSBL", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_DNSBL", 0);
	}
	
	
	if(!is_file("/etc/init.d/c-icap")){return;}
	$CicapEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CicapEnabled"));
	if($GLOBALS["VERBOSE"]){echo "CicapEnabled = $CicapEnabled ".__LINE__."\n";}
	$EnableSecurityAppliance=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSecurityAppliance");
	$WebFilteringRansomware=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WebFilteringRansomware"));

	$master_pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/c-icap/c-icap.pid");


	$l[]="[C-ICAP]";
	$l[]="service_name=APP_C_ICAP";
	$l[]="master_version=".$GLOBALS["CLASS_SOCKETS"]->GET_INFO("CicapVersion");
	$l[]="service_cmd=/etc/init.d/c-icap";
	$l[]="service_disabled=$CicapEnabled";
	$l[]="pidpath=/var/run/c-icap/c-icap.pid";
	$l[]="explain=enable_c_icap_text";
	$l[]="family=squid";

		


		if($CicapEnabled==0){
			return implode("\n",$l);return;
		}

		$binpath=$GLOBALS["CLASS_UNIX"]->find_program("c-icap");
		$l[]="binpath=$binpath";



		if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		    $master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($binpath);
		}

		if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			if(!$GLOBALS["DISABLE_WATCHDOG"]){
				if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3) {
                    squid_admin_mysql(0,"Starting Local ICAP service",null,__FILE__,__LINE__);
				    shell_exec2("$statx/exec.c-icap.php --start >/dev/null 2>&1 &");
                }
			}
			$l[]="running=0\ninstalled=1";$l[]="";
			return implode("\n",$l);

		}
		
        $time=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/icap_test_port.time");
		if($time>4){
			shell_exec2("$statx/exec.squid.watchdog.php --icap-tests  >/dev/null 2>&1 &");
		}


        shell_exec2("$statx/exec.c-icap.php --info >/dev/null 2>&1 &");

		c_icap_watchdog();
		$l[]="running=1";
		$l[]=GetMemoriesOf($master_pid);

		$l[]="";
		return implode("\n",$l);return;

}