<?php


function dbus(){

    $EnableDbusDaemon=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDbusDaemon"));
    $prefixcmd="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]}";


    if(is_file("/etc/init.d/dbus")) {
        if ($EnableDbusDaemon == 0) {
            squid_admin_mysql(0, "Removing service dbus daemon ( not enabled )", null, __FILE__, __LINE__);
            shell_exec("$prefixcmd /usr/share/artica-postfix/exec.dbus.php --uninstall >/dev/null 2>&1 &");
            return false;
        }else{
            return dbus_daemon();
        }
    }
    if(!is_file("/etc/init.d/dbus")) {
        if ($EnableDbusDaemon == 1) {
            squid_admin_mysql(0, "Installing service dbus daemon ( enabled )", null, __FILE__, __LINE__);
            shell_exec("$prefixcmd /usr/share/artica-postfix/exec.dbus.php --install >/dev/null 2>&1 &");
            return false;
        }else{
            return true;
        }
    }



}

function dbus_daemon_pid(){
    $pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/dbus/pid");
    if(!$GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
    $bin=$GLOBALS["CLASS_UNIX"]->find_program("dbus-daemon");
    return $GLOBALS["CLASS_UNIX"]->PIDOF($bin,true);
}

function dbus_daemon(){

    $bin=$GLOBALS["CLASS_UNIX"]->find_program("dbus-daemon");
    if(!is_file($bin)){
        $l[]="[APP_DBUS]";
        $l[]="service_name=APP_DBUS";
        $l[]="installed=0";
        implode("\n",$l);
    }

    $master_pid=dbus_daemon_pid();


    $l[]="[APP_DBUS]";
    $l[]="service_name=APP_DBUS";
    $l[]="master_version=".$GLOBALS["CLASS_SOCKETS"]->GET_INFO("dbus_daemon_version");
    $l[]="service_disabled=1";
    $l[]="watchdog_features=1";
    $l[]="family=system";

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){

        events("Not running pid `$master_pid`...",__FUNCTION__,__LINE__);
        if(!$GLOBALS["DISABLE_WATCHDOG"]){
            squid_admin_mysql(0,"{APP_DBUS} not running [action=start]", null,__FILE__,__LINE__);
            shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/dbus start");
        }
        $l[]="running=0";
        return implode("\n",$l);
    }
    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]="";
    return implode("\n",$l);
}

function udev(){

    if(!is_file("/etc/artica-postfix/settings/Daemons/EnableUdevDaemon")){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableUdevDaemon",1);
        $EnableUdevDaemon=1;
    }else{
        $EnableUdevDaemon=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUdevDaemon"));
    }


	$prefixcmd="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]}";


	if(is_file("/etc/init.d/udev")) {
        if ($EnableUdevDaemon == 0) {
            squid_admin_mysql(0, "Removing service udev daemon ( not enabled )", null, __FILE__, __LINE__);
            shell_exec("$prefixcmd /usr/share/artica-postfix/exec.udev-daemons.php --uninstall >/dev/null 2>&1 &");
            return false;
        }else{
            return udevd_daemon();
        }
    }
    if(!is_file("/etc/init.d/udev")) {
        if ($EnableUdevDaemon == 1) {
            squid_admin_mysql(0, "Installing service udev daemon ( enabled )", null, __FILE__, __LINE__);
            shell_exec("$prefixcmd /usr/share/artica-postfix/exec.udev-daemons.php --install >/dev/null 2>&1 &");
            return false;
        }else{
            return true;
        }
    }


}

function udevd_daemon(){

    $bin=$GLOBALS["CLASS_UNIX"]->find_program("udevd");
    if(is_file("/lib/systemd/systemd-udevd")){$bin="/lib/systemd/systemd-udevd";}

    $INSTALLED=true;
    if(!is_file($bin)){$INSTALLED=false;}
    if(!is_file("/etc/init.d/udev")){$INSTALLED=false;}

    if(!$INSTALLED){
        $l[]="[APP_UDEVD]";
        $l[]="service_name=APP_UDEVD";
        $l[]="installed=0";
        $l[]="service_disabled=0";
        implode("\n",$l);
    }
    $master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($bin,true);
    $APP_UDEV_VERSION=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_UDEV_VERSION");

    $l[]="[APP_UDEVD]";
    $l[]="service_name=APP_UDEVD";
    $l[]="master_version=$APP_UDEV_VERSION";
    $l[]="service_disabled=1";
    $l[]="watchdog_features=1";
    $l[]="family=system";
    $l[]="installed=1";

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
        $l[]="";
        return implode("\n",$l);
    }
    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]="";
    return implode("\n",$l);
}
//==============================================================================================================
