<?php

function statscom_pid(){
    $pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/artica-communicator.pid");
    if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
    return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("exec.StatsCommunicator.php");
}


function statscom(){

    $rfix="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    $EnableStatsCommunicator=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableStatsCommunicator"));


    if($EnableStatsCommunicator==0) {
        if (!is_file("/etc/init.d/statscom")) {
            return null;
        }else {
            squid_admin_mysql(0,
                "Uninstall Artica Status Communicator by default...", null,__FILE__,__LINE__);
            $cmd=trim("$rfix/exec.statscom.php --uninstall");
            shell_exec2($cmd);
            return null;
        }
    }

    if(!is_file("/etc/init.d/statscom")){
        squid_admin_mysql(0,
            "Install Artica Status Communicator by default... [action=install]",
            null,__FILE__,__LINE__);
        $cmd=trim("$rfix/exec.statscom.php --install");
        shell_exec2($cmd);
        return APP_STATS_REDIS();
    }

    $master_pid=statscom_pid();

    $l[]="[APP_STATS_COMMUNICATOR]";
    $l[]="service_name=APP_STATS_COMMUNICATOR";
    $l[]="service_cmd=/etc/init.d/statscom";
    $l[]="master_version=1.0";
    $l[]="service_disabled=1";
    $l[]="family=statistics";
    $l[]="watchdog_features=1";
    $l[]="installed=1";

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
        if(!$GLOBALS["DISABLE_WATCHDOG"]){
            $ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
            if($ServerRunSince>3){squid_admin_mysql(0,
                    "Artica Status Communicator service stopped [action=start]",
                    null,__FILE__,__LINE__);
            }
            $nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
            shell_exec2("$nohup /etc/init.d/statscom start >/dev/null 2>&1 &");
        }
        $l[]="running=0\ninstalled=1";
        $l[]=APP_STATS_REDIS();
        return implode("\n",$l);
    }
    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]=APP_STATS_REDIS();
    return implode("\n",$l);


}

function APP_STATS_REDIS_PID(){


    $pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/statsredis.pid");
    if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
    return $GLOBALS["CLASS_UNIX"]->PIDOF("/usr/sbin/statsredis");

}

function APP_STATS_REDIS(){
    $EnableStatsCommunicator=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableStatsCommunicator"));
    $rfix="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    $prodname="Artica Statistics memory database";

    if($EnableStatsCommunicator==0){
        if(is_file("/etc/init.d/statsredis")){
            squid_admin_mysql(0,
                "uninstall $prodname...", null,__FILE__,__LINE__);
            $cmd=trim("$rfix/exec.statscom.php --uninstall");
            shell_exec2($cmd);
            return;
        }
    }

    if($EnableStatsCommunicator==1){
        if(!is_file("/etc/init.d/statsredis")){
            squid_admin_mysql(0,
                "Install $prodname... [action=install]", null,__FILE__,__LINE__);
            $cmd=trim("$rfix/exec.statscom.php --install");
            shell_exec2($cmd);
            return;
        }
    }

    $master_pid=APP_STATS_REDIS_PID();

    $l[]="[APP_STATS_REDIS]";
    $l[]="service_name=APP_STATS_REDIS";
    $l[]="service_cmd=/etc/init.d/statsredis";
    $l[]="master_version=1.0";
    $l[]="service_disabled=1";
    $l[]="family=statistics";
    $l[]="watchdog_features=1";
    $l[]="installed=1";

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
        if(!$GLOBALS["DISABLE_WATCHDOG"]){
            $ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
            if($ServerRunSince>3){squid_admin_mysql(0, "$prodname stopped [action=start]", null,__FILE__,__LINE__);}
            $nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
            shell_exec2("$nohup /etc/init.d/statsredis start >/dev/null 2>&1 &");
        }
        $l[]="running=0\ninstalled=1";
        $l[]="";
        return implode("\n",$l);
    }
    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]="";
    return implode("\n",$l);

}

