<?php

function dnscrypt_proxy(){

	$EnableDNSCryptProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSCryptProxy"));


	$version=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_DNSCRYPT_PROXY_VERSION");
	$l[]="[APP_DNSCRYPT_PROXY]";
	$l[]="service_name=APP_DNSCRYPT_PROXY";
	$l[]="service_cmd=/etc/init.d/dnscrypt-proxy";
	$l[]="master_version=$version";
	$l[]="service_disabled=$EnableDNSCryptProxy";
	$l[]="family=dns";
	$l[]="watchdog_features=1";
	
	if($EnableDNSCryptProxy==0){return implode("\n",$l);}

	if(!is_file("/etc/init.d/dnscrypt-proxy")){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSCryptProxy",0);
        $nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
        shell_exec2("$nohup /etc/init.d/unbound restart >/dev/null 2>&1 &");
        return implode("\n",$l);
    }

	$master_pid=dnscrypt_proxy_pid();

	

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
			if($ServerRunSince>3){squid_admin_mysql(0, "DnsCrypt Proxy service stopped [action=start]", null,__FILE__,__LINE__);}
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			shell_exec2("$nohup /etc/init.d/dnscrypt-proxy start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";
		$l[]="";
		return implode("\n",$l);
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);
}


function unbound(){
    $cmdprf="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    if($GLOBALS["VERBOSE"]){echo "UNBOUND START....\n";}
    $UnboundEnabled=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled");
    $HaClusterClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));

    if($HaClusterClient==1){
       if($UnboundEnabled==1){
           shell_exec2("$cmdprf/exec.unbound.php --uninstall  >/dev/null 2>&1 &");
           return null;
       }
    }

    if($UnboundEnabled==0){
        return unbound_redis();
    }



	if(!is_file("/etc/init.d/unbound")){
        if($UnboundEnabled==1){
            squid_admin_mysql(0,"DNS Cache service is enabled but script is not installed [action=install]",null,__FILE__,__LINE__);
            shell_exec2("$cmdprf/exec.unbound.php --install  >/dev/null 2>&1 &");
            return null;
        }
    }

	$unbound_version=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundVersion");
	$l[]="[APP_UNBOUND]";
	$l[]="service_name=APP_UNBOUND";
	$l[]="service_cmd=/etc/init.d/unbound";
	$l[]="master_version=$unbound_version";
	$l[]="service_disabled=1";
	$l[]="family=dns";
	$l[]="watchdog_features=1";

	$master_pid=unbound_pid();


	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
			if($ServerRunSince>3){squid_admin_mysql(0, "DNS Cache service stopped [action=start]", null,__FILE__,__LINE__);}
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			shell_exec2("$nohup /etc/init.d/unbound start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";
		$l[]="";
        $l[]=unbound_redis();
		return implode("\n",$l);
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";

	$EnableUnboundBlackLists=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundBlackLists"));
	if($EnableUnboundBlackLists==1){
		$time=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.unbound.blacklists_download.time");
		if($time>384){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.unbound.php --blacklists-download  >/dev/null 2>&1 &");
		}

	}

	$unbound_control=$GLOBALS["CLASS_UNIX"]->find_program("unbound-control");
	if(is_file($unbound_control)){
		$time=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/logs/web/unbound.control.stats");
		if($time>10){
			@unlink("/usr/share/artica-postfix/ressources/logs/web/unbound.control.stats");
			$cmd="$unbound_control -c /etc/unbound/unbound.conf stats >/usr/share/artica-postfix/ressources/logs/web/unbound.control.stats 2>&1";
			shell_exec($cmd);
		}
	}

	$EnableDNSRootInts=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSRootInts"));
	if($EnableDNSRootInts==1){
		$time=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/unbound/root.hints");
		if($time>1880){
			$tmp=$GLOBALS["CLASS_UNIX"]->FILE_TEMP();
			include_once(dirname(__FILE__)."/ressources/class.ccurl.inc");
			$curl=new ccurl("https://www.internic.net/domain/named.cache");
			if($curl->GetFile($tmp)){
				@unlink("/etc/unbound/root.hints");
				@copy($tmp, "/etc/unbound/root.hints");
				@unlink($tmp);
				squid_admin_mysql(2, "[DNS]: Success refresh named.cache from www.internic.net", null,__FILE__,__LINE__);
				system("/etc/init.d/unbound reload");
			}
				
		}
	}

    $l[]=unbound_redis();
	return implode("\n",$l);
}

//---------------------------------------------------------------------------------------------------

function unbound_redis(){
    $cmdprf="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    $UnboundRedisEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundRedisEnabled"));
    $UnboundEnabled=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled");
    if($UnboundEnabled==0){$UnboundRedisEnabled=0;}
    
    if($UnboundRedisEnabled==0){
        if(is_file("/etc/init.d/unbound-redis")){
            squid_admin_mysql(0,"DNS Cache Database service is disabled but script is installed [action=uninstall]",null,__FILE__,__LINE__);
            shell_exec2("$cmdprf/exec.unbound.php --uninstall-redis  >/dev/null 2>&1 &");
        }
        return null;
    }

    if(!is_file("/etc/init.d/unbound-redis")){
        squid_admin_mysql(0,"DNS Cache Database service is enabled but script is uninstalled [action=install]",null,__FILE__,__LINE__);
        shell_exec2("$cmdprf/exec.unbound.php --install-redis >/dev/null 2>&1 &");
        return null;
    }

    $l[]="[UBOUND_REDIS]";
    $l[]="service_name=UBOUND_REDIS";
    $l[]="service_cmd=/etc/init.d/unbound-redis";
    $l[]="master_version=1.0";
    $l[]="service_disabled=1";
    $l[]="family=dns";
    $l[]="watchdog_features=1";
    $master_pid=unbound_redis_pid();

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
        if(!$GLOBALS["DISABLE_WATCHDOG"]){
            $ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
            if($ServerRunSince>3){squid_admin_mysql(0, "DNS Cache database service stopped [action=start]", null,__FILE__,__LINE__);}
            $nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
            shell_exec2("$nohup /etc/init.d/unbound-redis start >/dev/null 2>&1 &");
        }
        $l[]="running=0\ninstalled=1";
        $l[]="";
        return implode("\n",$l);
    }
    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]="";
    return implode("\n",$l);

}
function unbound_redis_pid(){
    $pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/unbound-database.pid");
    if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
    return $GLOBALS["CLASS_UNIX"]->PIDOF("/usr/sbin/unbound-db");
}

function unbound_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/unbound.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("unbound");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($Masterbin);
}
function dnscrypt_proxy_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/dnscrypt-proxy.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("dnscrypt-proxy");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($Masterbin);
}




//-