#!/usr/bin/env python
import sys
import dns.name
import dns.message
import dns.query
import dns.flags
from Crypto.Cipher import AES
import base64
import re
import traceback as tb

# https://coderoad.ru/46346371/%D0%9F%D1%80%D0%B5%D0%BE%D0%B1%D1%80%D0%B0%D0%B7%D0%BE%D0%B2%D0%B0%D0%BD%D0%B8%D0%B5-openssl-AES-%D0%B2-Php-%D0%B2-Python-AES
class RESOLVER:

    def __init__(self, debug):
        self.DNSServer=''
        self.DNSPort=''
        self.DnsDomain=''
        self.LocalNS=''
        self.error=''


    def LoadIngNameServer(self):
        if len(self.LocalNS)>2:
            return self.LocalNS

        self.LocalNS=self.resolfvonf()
        return self.LocalNS

    def resolfvonf(self):
        try:
            with open("/etc/resolv.conf", "r") as f:
                for line in f:
                    line=line.rstrip()
                    matches=re.search('^nameserver\s+([0-9\.]+)',line)
                    if matches:
                        return matches.group(1)
        except IOError:
            return False



    def MakeQuery(self,domain,hostname,port):

        if len(hostname)<2:
            hostname=self.LoadIngNameServer()
            port=53

        StringToQuery=domain+"."+DnsDomain
        StringToQuery = dns.name.from_text(StringToQuery)
        if not StringToQuery.is_absolute():
            StringToQuery = domain.concatenate(dns.name.root)

        request = dns.message.make_query(StringToQuery, dns.rdatatype.TXT)
        request.flags |= dns.flags.AD
        request.find_rrset(request.additional, dns.name.root, ADDITIONAL_RDCLASS,dns.rdatatype.OPT, create=True, force_unique=True)

        try:
            response = dns.query.udp(request, hostname, port=port,timeout=2,ignore_unexpected=True)
        except:
            self.error=tb.format_exc()
            return False

        if len(response.answer) == 0:
            return False;



